import java.lang.*;
import java.util.*;

class TransactionStore {

    private Vector transactions_;
    public Vector transactions() { return transactions_; }
    public void transactions(Vector theTrans) { transactions_ = theTrans; }

    private Enumeration enumeration_;
    public Enumeration enumeration() { return enumeration_; }
    public void enumeration(Enumeration anE) { enumeration_ = anE; }


    TransactionStore() {
        this.initialize();
    }

    private void initialize() {

        this.transactions(new Vector());

        CheckingAccount a = new CheckingAccount();
        a.customerName("Fred");
        a.id("234-34-7666");
        a.balance(66360.0);

        CheckingAccount b = new CheckingAccount();
        b.customerName("Bill");
        b.id("568-28-7556");
        b.balance(22.5);

        Vector theTrans = this.transactions();

        theTrans.addElement(new ReadyTellerTransaction (a, -20.0, new Date()));
        this.pause();
        theTrans.addElement(new MailTransaction        (a, +120.0,new Date()));
        this.pause();
        theTrans.addElement(new ReadyTellerTransaction (b, +40.0, new Date()));
        this.pause();
        theTrans.addElement(new ReadyTellerTransaction (b, -20.0, new Date()));
        this.pause();
        theTrans.addElement(new PersonalTransaction    (a, +100.0,new Date()));
        this.pause();
        theTrans.addElement(new PersonalTransaction    (a, +100.0,new Date()));
        this.pause();
        theTrans.addElement(new PersonalTransaction    (b, +99.99,new Date()));
        this.pause();
        this.enumeration(theTrans.elements());
    }

    public void pause(){
        try{Thread.sleep(1050);}
        catch(InterruptedException e){}
    }


    public Transaction getNext() {
        if (this.enumeration().hasMoreElements()) {
            return ((Transaction) this.enumeration().nextElement());
        }
        else { return null;}
    }

}
