import java.util.*;

class TransactionGenerator implements Runnable {

	private Bank bank_;
	private void bank( Bank aBank ) { bank_ = aBank; }
	private Bank bank() { return bank_; }

    TransactionGenerator(Bank aBank){
        this.bank(aBank);
        Thread aThread = new Thread(this);
        aThread.start();
    }

    public void run(){

        Account a = (Account) this.bank().getAccount("100");
        Account b = (Account) this.bank().getAccount("101");

        Vector v = new Vector();

        v.addElement(new ReadyTellerTransaction (a, -20.0, new Date()));
        v.addElement(new MailTransaction        (a, +120.0,new Date()));
        v.addElement(new ReadyTellerTransaction (b, +40.0, new Date()));
        v.addElement(new ReadyTellerTransaction (b, -20.0, new Date()));
        v.addElement(new PersonalTransaction    (a, +100.0,new Date()));
        v.addElement(new PersonalTransaction    (a, +100.0,new Date()));
        v.addElement(new PersonalTransaction    (b, +99.95,new Date()));
        v.addElement(new ReadyTellerTransaction (a, -30.0, new Date()));
        v.addElement(new MailTransaction        (a, +420.0,new Date()));
        v.addElement(new ReadyTellerTransaction (b, +50.0, new Date()));
        v.addElement(new ReadyTellerTransaction (b, -60.0, new Date()));
        v.addElement(new PersonalTransaction    (a, +700.0,new Date()));
        v.addElement(new PersonalTransaction    (a, -100.0,new Date()));
        v.addElement(new PersonalTransaction    (b, -19.95,new Date()));

        Enumeration transactions = v.elements();
        while( transactions.hasMoreElements() ){

            this.bank().processTransaction( (Transaction) transactions.nextElement());

            try{ Thread.sleep(500); }
            catch(InterruptedException ie){}
        }
    }

}