// package softcomputing;
import java.awt.*;
import java.util.*;
import java.lang.*;
import java.io.*;

public class Graph extends Observable {

    private Point graphSize_;
    public Point graphSize() { return graphSize_; }
    public void graphSize(Point theSize) { graphSize_ = theSize; }

    private double[] xSeries_;
    public double[] xSeries() { return xSeries_; }
    public void xSeries(double[] theData) { xSeries_ = theData;
                                this.maxX(this.findMax(theData));
                                this.minX(this.findMin(theData));}

    private double[] ySeries_;
    public double[] ySeries() { return ySeries_; }
    public void ySeries(double[] theData) { ySeries_ = theData;
                                this.maxY(this.findMax(theData));
                                this.minY(this.findMin(theData));}

    private double minX_;
    public double minX() { return minX_; }
    public void minX(double aDouble) { minX_ = aDouble; }

    private double maxX_;
    public double maxX() { return maxX_; }
    public void maxX(double aDouble) { maxX_ = aDouble; }

    private double minY_;
    public double minY() { return minY_; }
    public void minY(double aDouble) { minY_ = aDouble; }

    private double maxY_;
    public double maxY() { return maxY_; }
    public void maxY(double aDouble) { maxY_ = aDouble; }

    private String title_;
    public String title() { return title_; }
    public void title(String aTitle) { title_ = aTitle; }


    private Graph() {
        this.initialize();
    }

    public Graph(String aTitle) {
        this();
        this.title(aTitle);
    }


    private void initialize() {
        System.out.println("init Graph");
    }

    public void publicize() {
        this.setChanged();
        this.notifyObservers();
    }

    public void addYPoint(double aValue) {
        int i;
        double[] newYSeries = new double[this.ySeries().length + 1];
        for (i=0; i<this.ySeries().length; i++) {
            newYSeries[i] = this.ySeries()[i];
        }
        newYSeries[i] = aValue;
        this.ySeries(newYSeries); // replace the old series
                                 // with the longer one
    }

    public void plot() {

        int theSize = 0;

        if(this.xSeries() == null) {
            theSize = this.ySeries().length;

            this.xSeries(new double[theSize]);

            for (int i=0; i<theSize; i++) {
                this.xSeries()[i] = i;
            }

            this.minX(0);
            this.maxX(theSize-1);
        }

        this.publicize(); // tell the view we are done
    }

    public double findMin(double[] data) {

        double theMin = Double.POSITIVE_INFINITY;
        for (int i=0; i<data.length; i++) {
            if (data[i] < theMin)
                theMin = data[i];
        }
        return theMin;
    }

    public double findMax(double[] data) {

        double theMax = Double.NEGATIVE_INFINITY;
        for (int i=0; i<data.length; i++) {
            if (data[i] > theMax)
                theMax = data[i];
        }
        return theMax;
    }
}
