import java.lang.*;
import java.util.*;

class TransactionStore {

    private Vector transactions_;
    public Vector transactions() { return transactions_; }
    public void transactions(Vector theTrans) { transactions_ = theTrans; }

    private Enumeration enumeration_;
    public Enumeration enumeration() { return enumeration_; }
    public void enumeration(Enumeration anE) { enumeration_ = anE; }


    TransactionStore() {
        this.initialize();
    }

    private void initialize() {

        CheckingAccount a = new CheckingAccount();
        a.customerName("Fred");
        a.id("234-34-7666");
        a.balance(66360.0);

        this.transactions(new Vector());
        Vector theTrans = this.transactions();

        theTrans.addElement(new ReadyTellerTransaction (a, -20.0, new Date()));
        theTrans.addElement(new MailTransaction        (a, +120.0,new Date()));
        theTrans.addElement(new ReadyTellerTransaction (a, +40.0, new Date()));
        theTrans.addElement(new ReadyTellerTransaction (a, -20.0, new Date()));
        theTrans.addElement(new PersonalTransaction    (a, +100.0,new Date()));

        this.enumeration(theTrans.elements());
    }

    public Transaction getNext() {
        if (this.enumeration().hasMoreElements()) {
            return ((Transaction) this.enumeration().nextElement());
        }
        else { return null;}
    }
}
