import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
//import java.net.*;
import java.awt.image.*;
//import java.awt.image.MemoryImageSource;
import java.text.*;

class GraphTestView extends OOView {

    private GraphTest graphTest_;
    public GraphTest graphTest() { return graphTest_; }
    public void graphTest(GraphTest aGT) { graphTest_ = aGT; }

    GraphTestView(){
        super("Graph Tester");
        this.initialize();
    }

    public static void main(String argv[]){
        System.out.println("Top of main in GraphTestView");
        GraphTestView theGraphTestView = new GraphTestView();
        theGraphTestView.show();
    }

    private void initialize(){

        this.initMenu();

        // get the canvas width and height from the config file
        int widthC  = new Integer(Configuration.instance().valueOf("CANVASWIDTH")).intValue();
        int heightC = new Integer(Configuration.instance().valueOf("CANVASHEIGHT")).intValue();


        this.graphTest(new GraphTest());

        // now connect the graphs

        Graph theGraphA = this.graphTest().analyzerA().graph();
        Graph theGraphB = this.graphTest().analyzerB().graph();

        GraphView aGVA = new GraphView(widthC, heightC, theGraphA, this);
        aGVA.setSize(widthC,heightC);
        aGVA.setLocation(190,60);
        this.addWidget("AGraphView", aGVA);

        GraphView aGVB = new GraphView(widthC, heightC, theGraphB, this);
        aGVB.setSize(widthC,heightC);
        aGVB.setLocation(190,heightC+80);
        this.addWidget("BGraphView", aGVB);

// new stuff

        List listA = new List();
        listA.setSize(130,100);
        listA.setLocation(40,70);
        this.addWidget("TheAList", listA);

        List listB = new List();
        listB.setSize(130,100);
        listB.setLocation(40,heightC+90);
        this.addWidget("TheBList", listB);

        LoadButtonA buttonA = new LoadButtonA("Load", this);
        buttonA.setSize(40,20);
        buttonA.setLocation(50,heightC+30);
        this.addWidget("TheAButton", buttonA);

        LoadButtonB buttonB = new LoadButtonB("Load", this);
        buttonB.setSize(40,20);
        buttonB.setLocation(50,heightC+heightC+50);
        this.addWidget("TheBButton", buttonB);

        this.hookUpObservers();

        this.setSize(widthC+widthC+50, heightC+heightC+100);
        this.setLocation(100,100);
    }

    private void initMenu(){
        MenuBar aMenuBar = new MenuBar();

        Menu aMenu = new Menu("File");

        MenuItem aMenuItem = new MenuItem("Open");
        aMenuItem.addActionListener(this);
        aMenuItem.setActionCommand("OPEN");
        aMenu.add(aMenuItem);

        aMenuItem = new MenuItem("Exit");
        aMenuItem.addActionListener(this);
        aMenuItem.setActionCommand("EXIT");
        aMenu.add(aMenuItem);

        aMenuBar.add(aMenu);

        this.setMenuBar(aMenuBar);
    }

    public void actionPerformed(ActionEvent e){

        if(e.getActionCommand() == "OPEN"){
                this.open();
                this.repaint();
        }

        if(e.getActionCommand() == "EXIT"){
            this.dispose();
            System.exit(0);
        }
    }

    public void hookUpObservers(){
        this.graphTest().addObserver(this);
    }

    public void open() {
       ((GraphView) (this.getWidget("AGraphView"))).initializeGraphics();
       ((GraphView) (this.getWidget("BGraphView"))).initializeGraphics();

        this.graphTest().startTheEngine();
    }

    public void loadButtonAPressed() {

        NumberFormat theNF = NumberFormat.getNumberInstance();
        theNF.setMaximumFractionDigits(5);

        double[] dataSeries =
                   ((GraphView) (this.getWidget("AGraphView"))).ySeries();

        ((List) (this.getWidget("TheAList"))).removeAll();

        for (int i=0; i<dataSeries.length; i++) {
            ((List) (this.getWidget("TheAList")))
                                    .addItem(theNF.format(dataSeries[i]));
        }
    }

    public void loadButtonBPressed() {

        NumberFormat theNF = NumberFormat.getNumberInstance();
        theNF.setMaximumFractionDigits(5);

        double[] dataSeries =
                   ((GraphView) (this.getWidget("BGraphView"))).ySeries();
        ((List) (this.getWidget("TheBList"))).removeAll();
        for (int i=0; i<dataSeries.length; i++) {
            ((List) (this.getWidget("TheBList")))
                                    .addItem(theNF.format(dataSeries[i]));
        }
    }

    public void update(Graphics g) { paint(g); }

    public void update(Observable obs, Object o) {
        this.repaint();
    }

    public void paint(Graphics g) {
        // if this.model().outOfSoda ....
        g.setColor(Color.red);
        g.fillRect(400,300,20,20);
    }

    public void windowClosing(WindowEvent we){
        this.dispose();
        System.exit(0);
    }

}
