import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.rmi.*;
import java.rmi.server.*;
import java.net.*;

class ServoControllerView extends OOView implements Observer{

    public int i;
  //  public int i(){ return i_;}
  //  public void i(int y){i_ = y;}
    private ServoController servoController_;
    public ServoController servoController() { return servoController_; }
    public void servoController (ServoController aCtlr) {servoController_ = aCtlr; }

    public int lastY_;
    public int lastY(){ return lastY_;}
    public void lastY(int y){lastY_ = y;}

    public int lastX_;
    public int lastX(){ return lastX_;}
    public void lastX(int x){lastX_ = x;}

	/**
	 *  The offset of the box indicating the arm range of movement
	 */
	private int boxXOffset_;
	public int boxXOffset() { return boxXOffset_; }
	public void boxXOffset( int anInt ) { boxXOffset_ = anInt; }

	/**
	 *  The offset of the  same box
	 */
	private int boxYOffset_;
	public int boxYOffset() { return boxYOffset_; }
	public void boxYOffset( int anInt ) { boxYOffset_ = anInt; }

	/**
	 *  The width
	 */
	private int boxWidth_;
	public int boxWidth() { return boxWidth_; }
	public void boxWidth( int anInt ) { boxWidth_ = anInt; }

	/**
	 *  The height
	 */
	private int boxHeight_;
	public int boxHeight() { return boxHeight_; }
	public void boxHeight( int anInt ) { boxHeight_ = anInt; }

    ServoControllerView(){
        super("Servo Controller");
    }
    public static void main(String argv[]){
        ServoControllerView aServoController = new ServoControllerView();
        aServoController.show();
        aServoController.initialize();
    }
    public void initialize(){


        try {
            this.servoController(new ServoController());
        }
        catch (RemoteException e) {System.out.println("ServoController construction error");}

        // RMI registration
        this.registerServoController();

        this.hookupObservers();

        Label aLabel = new Label("Packets");
        aLabel.setSize(80,20);
        aLabel.setLocation(10,30);
        this.addWidget("listLabel",aLabel);

// box stuff
        this.boxWidth(100);
        this.boxHeight(140);
        this.boxXOffset ((300-100) / 2);
        this.boxYOffset ((300-140) / 2);

        i=40;
        this.setSize(300,300);

    }

    public void hookupObservers() {
        this.servoController().observableAssistant().addObserver(this);
    }

    public void registerServoController() {

        try {
            System.setSecurityManager(new RMISecurityManager());
            Naming.rebind("RemoteServoController", this.servoController());
        }
        catch (MalformedURLException e) {System.out.println("RMI-Error, bad URL");}
        catch (java.rmi.UnknownHostException e)  {System.out.println("RMI-Error, bad Host");}
        catch (RemoteException e)       {System.out.println("RMI-Error, remote exception");}
    }


    public void paint(Graphics g){
        int x=50;
        int y=80;
if (this.servoController()!=null) {
         x = this.servoController().servoAPosition();
         y = this.servoController().servoBPosition();
}
        // convert the servoposition to pixels

        x = x + this.boxXOffset() - 50;
        y = y + this.boxYOffset() - 80;

        g.setColor(Color.red);

        g.drawLine(1,y,255,y);
        g.drawLine(x,1,x,255);

        g.setColor (Color.green);

        g.drawRect (this.boxXOffset(), this.boxYOffset(),
                     this.boxWidth(), this.boxHeight());
    }

//    public void update(Graphics g) {paint(g);}

    public void update(Observable obs, Object o) {
        this.repaint();
    }

    public void mouseDragged(MouseEvent e){}
    public void testButton(){}


}
