import java.util.*;

class Driver {


	/**
	 */
	private Car car_;
	public Car car() { return car_; }
	public void car( Car aCar ) { car_ = aCar; }

	/**
	 */
	private TrafficLiteSimulator trafficLiteSimulator_;
	public TrafficLiteSimulator trafficLiteSimulator() { return trafficLiteSimulator_; }
	public void trafficLiteSimulator( TrafficLiteSimulator aTrafficLiteSimulator ) { trafficLiteSimulator_ = aTrafficLiteSimulator; }

	/**
	 */
	private Path path_;
	public Path path() { return path_; }
	public void path( Path aPath ) { path_ = aPath; }

	/**
	 *  This collection of cars may change with each heatbeat.
	 *  Membership in this set depends on if the car is on one of
	 *  the possible paths for sharing this lane, and if the car is
	 *  actually graphically in the way of this car.
	 */
	private Vector carsToAvoid_;
	public Vector carsToAvoid() { return carsToAvoid_; }
	public void carsToAvoid( Vector aVector ) { carsToAvoid_ = aVector; }

	/**
	 *  A one to ten scale of how lead-footed this driver is.
	 */
	private int leadFootIndex_;
	public int leadFootIndex() { return leadFootIndex_; }
	public void leadFootIndex( int anInt ) { leadFootIndex_ = anInt; }

    public void heartBeat(){
        // what are all the things that the driver must
        // do at each heartBeat ?

        // He must decide how much to accelerate
        // In order to do that he needs to know
        //      1   how far away is he from any car who is
        //          legitimately ahead of him, meaning
        //              1   is on one of the possible paths
        //                  for a car in front
        //              2   is actually in the way, unlike if
        //                  the front car had turned right and
        //                  was out of the way of the following
        //                  car.
        //      2   is there a light that effects him?
        //          if green then it has no effect
        //              on the current acceleration.
        //          if red, then how far away is the line?
        //              must stop before the line.
        //          if yellow, then how long has it been yellow
        //              and how far away is the line, and
        //      3   is he making a right turn on a red light?
        //          if so, how far away is the nearest car in one of
        //              the two possible merging lanes and
        //              how fast is it going. It must not be past
        //              him as well.

        // do we want the driver to take into consideration
        //      how fast the car in front is moving? Most
        //      drivers do.

        // in that case the light could have speed zero and
        //      cars in front and lights could be in the same
        //      group called obstacles or something like that.

        // perhaps a car should have a velocity vector holding
        //      the speed and direction, and whether another
        //      car is moving away or towards you is the sign
        //      of the rate of change of the distance between
        //      the two cars.


    }
}