import java.util.*;

class NorthThruLane extends Lane {
    NorthThruLane(TrafficLiteController tlc){
        super(tlc);
        RegularLightBox aRLB = new RegularLightBox();
        aRLB.addObserver(this);
        this.lightBox( aRLB );
    }
    public void sensorActivated(){
        System.out.println("sensorActivated in NorthThruLane");
        this.greenRequest( new GreenRequest() );
    }
    public void setConflicts(){
        this.conflictingLanes().addElement( this.trafficLiteController().getLane( "EastLeftLane" ) );
        this.conflictingLanes().addElement( this.trafficLiteController().getLane( "SouthLeftLane" ) );
        this.conflictingLanes().addElement( this.trafficLiteController().getLane( "WestLeftLane" ) );
        this.conflictingLanes().addElement( this.trafficLiteController().getLane( "EastThruLane" ) );
        this.conflictingLanes().addElement( this.trafficLiteController().getLane( "WestThruLane" ) );
        this.conflictingLanes().addElement( this.trafficLiteController().getLane( "NorthPedLane" ) );
        this.conflictingLanes().addElement( this.trafficLiteController().getLane( "SouthPedLane" ) );
   }

	public void update(Observable obs, Object o){
	    if( ((String) o).equals("resetGreenRequest")){
	        this.greenRequest(null);
	        return;
	    }
		this.trafficLiteController().instructLight( "NSLight" ,(String) o);
	}
}