import java.util.*;

class TrafficLiteSimulator {

	/**
	 */
	private Vector drivers_;
	public Vector drivers() { return drivers_; }
	public void drivers( Vector aVector ) { drivers_ = aVector; }

	/**
	 */
	private TLCView view_;
	public TLCView view() { return view_; }
	public void view( TLCView aTLCView ) { view_ = aTLCView; }

	/**
	 */
	private TLCAdapter tlcAdapter_;
	public TLCAdapter tlcAdapter() { return tlcAdapter_; }
	public void tlcAdapter( TLCAdapter aTLCAdapter ) { tlcAdapter_ = aTLCAdapter; }

    TrafficLiteSimulator(TLCView aView){
        this();
        this.view( aView );
    }
    TrafficLiteSimulator(){
        this.tlcAdapter(new TLCAdapter());
        this.tlcAdapter().trafficLiteSimulator(this); // hookup the reverse reference

    }
    public void updateSimulator(String widgetName, String command){
        this.view().update(widgetName, command);

    }
    public void instructLight(String widgetName, String command){
        this.view().update(widgetName, command);

    }

    public void nPedLite(String s){
        this.updateView("NPedLight1",s);
        this.updateView("NPedLight2",s);
    }
    public void sPedLite(String s){
        this.updateView("SPedLight1",s);
        this.updateView("SPedLight2",s);
    }
    public void ePedLite(String s){
        this.updateView("EPedLight1",s);
        this.updateView("EPedLight2",s);
    }
    public void wPedLite(String s){
        this.updateView("WPedLight1",s);
        this.updateView("WPedLight2",s);
    }

    public void northThruLite(String s){
        this.updateView("NSLight",s);
    }
    public void northLeftLite(String s){
        this.updateView("NLLight",s);
    }
    public void southThruLite(String s){
        this.updateView("SSLight",s);
    }
    public void southLeftLite(String s){
        this.updateView("LSLight",s);
    }
    public void eastThruLite(String s){
        this.updateView("ESLight",s);
    }
    public void eastLeftLite(String s){
        this.updateView("ELLight",s);
    }
    public void westThruLite(String s){
        this.updateView("WSLight",s);
    }
    public void westLeftLite(String s){
        this.updateView("WLLight",s);
    }

    private void updateView(String widgetName, String command){
        this.view().update(widgetName, command);
    }

    public void sensorButtonPressed(String actionCommand){
        System.out.println("sensorButtonPressed in TrafficLiteSimulator " + actionCommand);
        if( actionCommand.equals( "ns" ) ){
            this.tlcAdapter().nThruTrig();
            return;
        }
        if( actionCommand.equals( "nl" ) ){
            this.tlcAdapter().nLeftTrig();
            return;
        }
        if( actionCommand.equals( "ss" ) ){
            this.tlcAdapter().sThruTrig();
            return;
        }
        if( actionCommand.equals( "sl" ) ){
            this.tlcAdapter().sLeftTrig();
            return;
        }
        if( actionCommand.equals( "es" ) ){
            this.tlcAdapter().eThruTrig();
            return;
        }
        if( actionCommand.equals( "el" ) ){
            this.tlcAdapter().eLeftTrig();
            return;
        }
        if( actionCommand.equals( "ws" ) ){
            this.tlcAdapter().wThruTrig();
            return;
        }
        if( actionCommand.equals( "wl" ) ){
            this.tlcAdapter().wLeftTrig();
            return;
        }
    }
    public void pedestrianButtonPressed(String actionCommand){
        if( actionCommand.equals( "nw" ) ){
            this.tlcAdapter().nwPedTrig();
            return;
        }
        if( actionCommand.equals( "ne" ) ){
            this.tlcAdapter().nePedTrig();
            return;
        }
        if( actionCommand.equals( "sw" ) ){
            this.tlcAdapter().swPedTrig();
            return;
        }
        if( actionCommand.equals( "se" ) ){
            this.tlcAdapter().sePedTrig();
            return;
        }
        if( actionCommand.equals( "wn" ) ){
            this.tlcAdapter().wnPedTrig();
            return;
        }
        if( actionCommand.equals( "ws" ) ){
            this.tlcAdapter().wsPedTrig();
            return;
        }
        if( actionCommand.equals( "en" ) ){
            this.tlcAdapter().enPedTrig();
            return;
        }
        if( actionCommand.equals( "es" ) ){
            this.tlcAdapter().esPedTrig();
            return;
        }
    }
    public void heartBeat(){
        //  go through drivers calling heartbeat() in each
        Enumeration theDrivers = this.drivers().elements();
        while( theDrivers.hasMoreElements() ){
            Driver aDriver = (Driver) theDrivers.nextElement();
        }

        // should we update all the pictures at once or
        // during the heartBeat() of each driver?

        // at some point we need to deal with which sensors
        // and pedestrian buttons were hit during the
        // heartBeat

        // do we know exactly how to get the lights to change?



        this.detectCollisions();

    }
    public void detectCollisions(){

    }
}
