import java.lang.*;
import java.util.*;

class PromoKids extends Promotion{

    PromoKids() {
        this.initialize();
    }

    private void initialize() {
        this.name("Free kid movie for each regular movie");
        this.description("If the customer rents a regular movie" +
                                           " he gets a kids one free");
        this.id("b");
        this.active(true);
    }

    public double promoPrice(Customer aCustomer) {

        // see if this promo applies

        // first check if two tapes are being purchased
        // here we do not care if they are any category
        // but we could check ..


        if (aCustomer.basket().tapeCount() < 2){
        System.out.println("result from thursday = " + Double.POSITIVE_INFINITY);
            return Double.POSITIVE_INFINITY;
        }

        // is there a kids tape in the basket

        int kidTapesPresent = 0;
        Tape aKidTape = null;

        Enumeration theTapes = aCustomer.basket().tapes().elements();
        while (theTapes.hasMoreElements()) {
            Tape aTape = (Tape) theTapes.nextElement();
            Enumeration theCategories = aTape.categories().elements();
            while (theCategories.hasMoreElements()) {
                String aCategory = (String) theCategories.nextElement();
                if(aCategory.equals(Tape.CATEGORYCHILDREN)) {
                    kidTapesPresent++;
                    aKidTape = aTape;    // the last kid tape in the basket
                                              // will be free if all the requirements
                                              // are met
                }
            }
        }

        if (kidTapesPresent == 0) return Double.POSITIVE_INFINITY;

        // is there at least one non-kid tape in the basket

        if ((aCustomer.basket().tapeCount() - kidTapesPresent) <= 0) {
            return Double.POSITIVE_INFINITY;
        }

        // well we have satisfied the requirements so let us do it


         double result = aCustomer.basket().regularCost()
                                       - aKidTape.rentalPrice();

        System.out.println("result from Kid = " + result);
        return result;
    }

    public boolean applicable(Customer aCustomer) {
        return true;
    }

}