import java.lang.*;
import java.util.*;

abstract class Promotion {

	/**
	 *  Effective date for the start of this promotion
	 */
	private Date startDate_;
	public Date startDate() { return startDate_; }
	public void startDate( Date aDate ) { startDate_ = aDate; }

	/**
	 *  Effective date for the end of this promotion
	 */
	private Date endDate_;
	public Date endDate() { return endDate_; }
	public void endDate( Date aDate ) { endDate_ = aDate; }

	/**
	 *  Promotion name
	 */
	private String name_;
	public String name() { return name_; }
	public void name( String aString ) { name_ = aString; }

	/**
	 *  Promotion description
	 */
	private String description_;
	public String description() { return description_; }
	public void description( String aString ) { description_ = aString; }

	/**
	 *  A one character string which is the identifier of this promotion.
	 *  This is used when promotions are interrelated with one another.
	 */
	private String id_;
	public String id() { return id_; }
	public void id( String aString ) { id_ = aString; }

	/**
	 *  True is this promotion is currently allowed (the promotion
	 *  may still be restricted by the start and end dates)
	 */
	private boolean active_;
	public boolean active() { return active_; }
	public void active( boolean aBoolean ) { active_ = aBoolean; }

    Promotion () {
        this.initialize();
    }

    private void initialize() {
    }

    abstract double promoPrice(Customer aCustomer);
    abstract boolean applicable(Customer aCustomer);


}