import java.util.*;
import java.lang.*;

class Zoo extends Observable {

    private String name_;
    public String name() { return name_; }
    public void name(String aName) {name_ = aName; }

    private Vector animals_;
    public Vector animals() { return animals_; }
    public void animals(Vector theAnimals) { animals_ = theAnimals; }

    Zoo() {
        this.initialize();
    }

    private void initialize() {
        this.animals(new Vector());
        this.name("Fred's Zoo");

        Vector theAs  = this.animals();
        theAs.addElement(new Animal("George", 2));
        theAs.addElement(new Animal("Centi",  43));
        theAs.addElement(new Animal("Wormy",  0));
        theAs.addElement(new Animal("Yogi",   4));

    }

    public void publicize(String aString) {
        this.setChanged();
        this.notifyObservers(aString);
    }

    public int computeFootCount() {
        int totalFootCount = 0;
        Enumeration theAnimals = this.animals().elements();
        while (theAnimals.hasMoreElements()) {
            Animal anAnimal = (Animal) theAnimals.nextElement();
            totalFootCount = totalFootCount +
                                anAnimal.footCount();
        }
        this.publicize("Shoes to order = " + totalFootCount);
        return totalFootCount;
    }
}


