import java.awt.*;
import java.io.*;
import java.awt.event.*;
import java.util.*;

class ZooView extends SCView {

	/**
	 */
	private Zoo zoo_;
	private Zoo zoo() { return zoo_; }
	private void zoo( Zoo aZoo ) { zoo_ = aZoo; }

    private ZooView(){
        super("Zoo View");
        this.initialize();
    }

    public static void main(String argv[]){
        ZooView theZooView = new ZooView();
        theZooView.show();
        theZooView.zoo().startTheEngine();

    }

    private void initialize(){

        this.zoo( new Zoo() );

        this.zoo().addObserver(this);


        this.setLayout(null);

        this.initMenu();

        this.initWidgets();

        this.setSize(500,480);
        this.setLocation(80,80);

    }

    private void initWidgets(){
        Label aLabel = new Label("zoo name");
        aLabel.setSize(500,40);
        aLabel.setLocation(0,60);
        aLabel.setFont(new Font("Courier",0,22));
        aLabel.setAlignment(Label.CENTER);
        this.addWidget("zoo name Label",aLabel);

        aLabel = new Label("--");
        aLabel.setSize(200,30);
        aLabel.setLocation(340,130);
        aLabel.setFont(new Font("Courier",0,16));
        aLabel.setAlignment(Label.LEFT);
        this.addWidget("current population Label", aLabel);

        aLabel = new Label("Current Population:");
        aLabel.setSize(200,30);
        aLabel.setLocation(100,130);
        aLabel.setFont(new Font("Courier",0,16));
        aLabel.setAlignment(Label.RIGHT);
        this.add(aLabel);

        aLabel = new Label("--");
        aLabel.setSize(100,30);
        aLabel.setLocation(320,190);
        aLabel.setFont(new Font("Courier",0,16));
        aLabel.setAlignment(Label.LEFT);
        this.addWidget("foot count Label", aLabel);

        this.addWidget("compute foot count Button", new FootCountButton(this));

        aLabel = new Label("Compute Foot Count");
        aLabel.setSize(210,30);
        aLabel.setLocation(5,190);
        aLabel.setFont(new Font("Courier",0,16));
        aLabel.setAlignment(Label.RIGHT);
        this.add(aLabel);


        this.addWidget("animal List", new AnimalList(this));

        aLabel = new Label("Name:");
        aLabel.setSize(100,30);
        aLabel.setLocation(250,300);
        aLabel.setFont(new Font("Courier",0,14));
        aLabel.setAlignment(Label.RIGHT);
        this.add(aLabel);

        aLabel = new Label("Foot Count:");
        aLabel.setSize(100,30);
        aLabel.setLocation(250,340);
        aLabel.setFont(new Font("Courier",0,14));
        aLabel.setAlignment(Label.RIGHT);
        this.add(aLabel);

        aLabel = new Label("--");
        aLabel.setSize(100,30);
        aLabel.setLocation(370,300);
        aLabel.setFont(new Font("Courier",0,14));
        aLabel.setAlignment(Label.LEFT);
        this.addWidget("selected name Label", aLabel);

        aLabel = new Label("--");
        aLabel.setSize(100,30);
        aLabel.setLocation(370,340);
        aLabel.setFont(new Font("Courier",0,14));
        aLabel.setAlignment(Label.LEFT);
        this.addWidget("selected foot count Label", aLabel);


    }

    public void animalListClicked(String selectedAnimalName){
        System.out.println("animalListClicked and name = " + selectedAnimalName);

        Animal selectedAnimal = this.zoo().animalForName(selectedAnimalName);
        ((Label) this.getWidget("selected foot count Label")).setText("" + selectedAnimal.footCount());
        ((Label) this.getWidget("selected name Label")).setText(selectedAnimal.name());
    }

    public void footCountButtonPressed(){
        System.out.println("footCountButtonPressed");

        ((Label) this.getWidget("foot count Label")).setText("" + this.zoo().computeFootCount());


    }

    public void update(Observable obs, Object o){

        Zoo theZoo = (Zoo) obs;

        ((Label) this.getWidget("foot count Label")).setText("--");
        ((Label) this.getWidget("selected name Label")).setText("--");
        ((Label) this.getWidget("selected foot count Label")).setText("--");
        ((Label) this.getWidget("current population Label")).setText("" + theZoo.currentPopulation());
        ((Label) this.getWidget("zoo name Label")).setText(theZoo.name());


        AnimalList animalList = (AnimalList) this.getWidget("animal List");
        animalList.resetItems(theZoo.animalNames());
        animalList.select(0);

        Animal selectedAnimal = this.zoo().animalForName(animalList.getSelectedItem());
        ((Label) this.getWidget("selected foot count Label")).setText("" + selectedAnimal.footCount());
        ((Label) this.getWidget("selected name Label")).setText(selectedAnimal.name());

    }

    private void initMenu(){
        MenuBar aMenuBar = new MenuBar();


            Menu aMenu = new Menu("File");
                MenuItem aMenuItem = new MenuItem("Exit");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Exit");
            aMenu.add(aMenuItem);

        aMenuBar.add(aMenu);


        this.setMenuBar(aMenuBar);
    }

   public void actionPerformed(ActionEvent e){
        String actionCommand = e.getActionCommand();

        if( actionCommand.equals("Exit") ){
            this.exit();
            return;
        }
    }


    public void windowClosing(WindowEvent we){
        this.exit();
    }
    private void exit(){
        System.out.println("exit() in ZooView");
        try{ Thread.sleep(500); }
        catch(InterruptedException ie){}
        this.dispose();
        System.exit(0);
    }

}

