import java.util.*;
import java.lang.*;

class Car {

	/**
	 *  An indicator of the performance level of this Car
	 */
	private int speedCapability_;
	public int speedCapability() { return speedCapability_; }
	public void speedCapability( int anInt ) { speedCapability_ = anInt; }

	/**
	 *  Velocity of this Car in units/heartbeat. Each Track that
	 *  the VisibleCar follows is divided into 4000 units across
	 *  its entire length. Thus this currentVelocity is the number
	 *  of units this Car will advance in its 'track' for each heartbeat
	 */
	private int currentVelocity_;
	public int currentVelocity() { return currentVelocity_; }
	public void currentVelocity( int anInt ) { currentVelocity_ = anInt; }

	/**
	 *  The acceleration for this Car. It has the units
	 *  units/heartbeat/heartbeat
	 */
	private int acceleration_;
	public int acceleration() { return acceleration_; }
	public void acceleration( int anInt ) { acceleration_ = anInt; }

	/**
	 *  The VisibleCar associated with this Car. The VisibleCar
	 *  is displayed on the View.
	 */
	private VisibleCar visibleCar_;
	public VisibleCar visibleCar() { return visibleCar_; }
	public void visibleCar( VisibleCar aVisibleCar ) { visibleCar_ = aVisibleCar; }

	/**
	 *  The Driver associated with this Car.
	 */
	private Driver driver_;
	public Driver driver() { return driver_; }
	public void driver( Driver aDriver ) { driver_ = aDriver; }

    Car() {
        this.initialize();
    }

    Car(Driver aDriver, Track aTrack) {
        this();
        this.driver(aDriver);
        this.visibleCar(new VisibleCar()); // set the track later

        // this failed because of the initialization sequence
      //  this.driver().trafficLiteSimulator()
     //                  .trafficLiteSimulatorView()
     //                  .addVisibleCar(this.visibleCar());

    }

    private void initialize() {
        this.speedCapability(50);
        this.currentVelocity(50);
        this.acceleration(5);
    }

    public void updateVelocity(Track theTrack) {
        int nextVelocity = this.currentVelocity() + this.acceleration();
        if (nextVelocity < 0) nextVelocity = 0;

        this.currentVelocity(nextVelocity);
        this.visibleCar().updatePixWithVelocity(this.currentVelocity(), theTrack);
    //    System.out.println("current velocity = " + this.currentVelocity());
    }
}
