import java.lang.*;
import java.util.*;

class CoinBucket extends Observable {

	/*
	*/
	private Vector coinBank_;
	public Vector coinBank() { return coinBank_; }
	public void coinBank( Vector aVector ) { coinBank_ = aVector; }

	/*
	*/
	private Vector coins_;
	public Vector coins() { return coins_; }
	public void coins( Vector aVector ) { coins_ = aVector; }

	CoinBucket() {
	    this.initialize();
	}

	private void initialize() {
	    this.coinBank(new Vector());
	    this.coins(new Vector());
	}

	public void returnCoins() {
	}

	public void storeCoins() {
	    Enumeration theBucket = this.coins().elements();
	    while (theBucket.hasMoreElements()) {
	        Coin aCoin = (Coin) theBucket.nextElement();
	        this.coinBank().addElement(aCoin);
	    }
	    this.coins(new Vector());
	    this.publicize();
	}

	public void addCoin(Coin aCoin) {
	    this.coins().addElement(aCoin);
	    this.publicize();
	}

	public int countCoins() {
	    int amount = 0;
	    Enumeration theBucket = this.coins().elements();
	    while (theBucket.hasMoreElements()) {
	        Coin aCoin = (Coin) theBucket.nextElement();
	        amount += aCoin.value();
	    }
	    return amount;
	}

	public void publicize() {
	    this.setChanged();
	    this.notifyObservers(new Integer(this.countCoins()));
	}

}
