import java.text.*;
import java.util.*;

class CoinManager extends Observable  {

	/*
	*/
	private ChangeDispenser changeDispenser_;
	public ChangeDispenser changeDispenser() { return changeDispenser_; }
	public void changeDispenser( ChangeDispenser aChangeDispenser ) { changeDispenser_ = aChangeDispenser; }

	/*
	*/
	private CoinBucket coinBucket_;
	public CoinBucket coinBucket() { return coinBucket_; }
	public void coinBucket( CoinBucket aCoinBucket ) { coinBucket_ = aCoinBucket; }


	CoinManager() {
	    this.initialize();
	}

	private void initialize() {
	    this.changeDispenser(new ChangeDispenser());
	    this.coinBucket(new CoinBucket());
	}

	public int amountDeposited() {
	   return this.coinBucket().currentValue();
	}

    public void bankCoins() {
        this.coinBucket().storeCoins();
        this.publicize(this.amountDepositedAsString());
    }

    public boolean moneyRequired (int amount) {
        return (amount <= this.amountDeposited());
    }

    public void dispenseChange(int amount) {
        this.changeDispenser().dispenseChange(amount);
    }

    public void registerCoin(Coin aCoin) {
        this.coinBucket().addCoin(aCoin);
        this.publicize(this.amountDepositedAsString());
    }

    public String amountDepositedAsString() {
        double viewableAmount = this.amountDeposited() / 100.0;
        NumberFormat theNF = NumberFormat.getCurrencyInstance();
        String amountString = theNF.format(viewableAmount);
        return amountString;
    }

    public void coinsHaveBeenReturned() {
        this.coinBucket().coinsHaveBeenReturned();
        publicize(this.amountDepositedAsString());
    }

	public void publicize(String amountDeposited){
	    System.out.println("publicize in CoinCounter");
	    this.setChanged();
	    this.notifyObservers(amountDeposited);
	}


}
