import java.util.*;
import java.lang.*;
import java.awt.Polygon;

class CollisionDetector {

	/**
	 */
	private Combiner combiner_;
	private Combiner combiner() { return combiner_; }
	private void combiner( Combiner aCombiner ) { combiner_ = aCombiner; }

    CollisionDetector() {
        this.initialize();
    }

    private void initialize() {
        this.combiner( new Combiner() );
    }

    public void detectCollisionsFor(Vector visibleCars) {
        Enumeration combos = this.combiner().combine(visibleCars,2);
        while(combos.hasMoreElements()){
            Vector aCombo = (Vector) combos.nextElement();

            TravelerFrame tf1 = ((VisibleCar) aCombo.elementAt(0)).currentTravelerFrame();
            TravelerFrame tf2 = ((VisibleCar) aCombo.elementAt(1)).currentTravelerFrame();
            int x1 = tf1.position().x;
            int y1 = tf1.position().y;
            int x2 = tf1.position().x;
            int y2 = tf1.position().y;
            if( Math.sqrt((x1-x2)*(x1-x2) + (y1-y2)*(y1-y2)) < 40 ){

                this.detectCollision(tf1.polygon(),tf2.polygon());
            }
        }

    }
    private void detectCollision(Polygon p1, Polygon p2){



        int x1,y1,x2,y2;
        for( int i = 0; i<4; i++ ){
            x1 = p1.xpoints[i];
            y1 = p1.ypoints[i];
            x2 = p2.xpoints[i];
            y2 = p2.ypoints[i];
            if( p2.contains(x1,y1) | p1.contains(x2,y2) ){
                System.out.println("CRASH CRASH CRASH CRASH CRASH");
            }
        }
    }


}