import java.lang.*;
import java.util.*;

class Dispenser {

	/*
	*/
	private DispenseButton dispenseButton_;
	public void dispenseButton( DispenseButton aDispenseButton ) { dispenseButton_ = aDispenseButton; }
	public DispenseButton dispenseButton() { return dispenseButton_; }

	/*
	*/
	private DispenserGate dispenserGate_;
	public void dispenserGate( DispenserGate aDispenserGate ) { dispenserGate_ = aDispenserGate; }
	public DispenserGate dispenserGate() { return dispenserGate_; }

	/*
	*/
	private SoldOutSensor soldOutSensor_;
	public SoldOutSensor soldOutSensor() { return soldOutSensor_; }
	private void soldOutSensor( SoldOutSensor aSoldOutSensor ) { soldOutSensor_ = aSoldOutSensor; }


	/**
	 *  Manages the coins for this VendingMachine
	 */
	private CoinManager coinManager_;
	public CoinManager coinManager() { return coinManager_; }
	public void coinManager( CoinManager aCoinManager ) { coinManager_ = aCoinManager; }

	/*
	*/
	private int drinkPrice_;
	public int drinkPrice() { return drinkPrice_; }
	public void drinkPrice( int aPrice ) { drinkPrice_ = aPrice; }


	Dispenser() {
	    this.initialize();
	}

	private void initialize() {
	    this.dispenseButton(new DispenseButton());
	    this.dispenserGate(new DispenserGate());
	    this.soldOutSensor(new SoldOutSensor());
	    this.coinManager(new CoinManager());
	    this.drinkPrice(35);

	    this.soldOutSensor().updateSoldOutLite();
	}

	public void dispenseButtonPressed() {

	    if (this.soldOutSensor().isOn()) return;

	    if( this.coinManager().moneyRequired (this.drinkPrice())) {

	        System.out.println("deposited = " + this.coinManager().amountDeposited());

	        this.coinManager().dispenseChange(
	                            this.coinManager().amountDeposited() -
	                                                      this.drinkPrice());
	        this.dispenserGate().releaseOne();

	        this.coinManager().bankCoins();

	        this.soldOutSensor().updateSoldOutLite();

	    }
	}
}
