import java.util.*;

class Driver {

	/**
	 *  This collection of cars may change with each heatbeat.
	 *  Membership in this set depends on if the car is on one of
	 *  the possible paths for sharing this lane, and if the car is
	 *  actually graphically in the way of this car.
	 */
	private Vector carsToAvoid_;
	public Vector carsToAvoid() { return carsToAvoid_; }
	public void carsToAvoid( Vector aVector ) { carsToAvoid_ = aVector; }

	/**
	 *  A one to ten scale of how lead-footed this driver is.
	 */
	private int leadFootIndex_;
	public int leadFootIndex() { return leadFootIndex_; }
	public void leadFootIndex( int anInt ) { leadFootIndex_ = anInt; }


	/**
	 *  The car this Drive is driving
	 */
	private Car car_;
	public Car car() { return car_; }
	public void car( Car aCar ) { car_ = aCar; }

	/**
	 *  The TrafficLiteSimulator this Driver is driving in
	 */
	private TrafficLiteSimulator trafficLiteSimulator_;
	public TrafficLiteSimulator trafficLiteSimulator() { return trafficLiteSimulator_; }
	public void trafficLiteSimulator( TrafficLiteSimulator aTLS ) { trafficLiteSimulator_ = aTLS; }

    Driver() {
        this.initialize();
    }

    Driver (TrafficLiteSimulator aTrafficLiteSimulator, Track aTrack) {
        this();
        this.trafficLiteSimulator(aTrafficLiteSimulator);
        this.car(new Car(this, aTrack));
    }

    private void initialize() {
    }

    public void lookForSignalsAndReact(TLSView theView, Track theTrack) {

        int stoppingAcceleration = 0;
        int distanceToLite = 0;

        // look for a non-green lite

        distanceToLite =  theTrack.sensor().highLimit() - this.car().visibleCar().position();
        if (distanceToLite == 0) {
            stoppingAcceleration = -9999;
        }
        else {
            stoppingAcceleration = this.car().currentVelocity() / distanceToLite;
        }

        if (!   ( (LightBoxWidget) (theView.getWidget(theTrack.lightName()))).isGreen()     ){
            this.car().acceleration(0-stoppingAcceleration);
         //   System.out.println("asdflksjdfj " + (0 - stoppingAcceleration));
        }

        else {
            this.car().acceleration(10);
        }
      //  this.car().acceleration(4);
        this.car().updateVelocity(theTrack);
     //   System.out.println("analyzing situation");
    }


}