/*+========================================================================+*/
/*| [FBN ARS     ], Copyright [1999] [FBN Software]  All Rights Reserved.  |*/
/*|------------------------------------------------------------------------|*/
/*| NOTE: This software contains valuable trade secrets and proprietary    |*/
/*| information of [FBN Software] and is protected by law. It may not be   |*/
/*| copied or distributed in any form or medium, disclosed to third        |*/
/*| parties, reverse engineered or used in any manner without prior        |*/
/*| written authorization from [FBN Software].                             |*/
/*|------------------------------------------------------------------------|*/
/*| FILE: FlightLeg.java                                                   |*/
/*|------------------------------------------------------------------------|*/
/*| MODULE:                                                                |*/
/*|------------------------------------------------------------------------|*/
/*| Who | Date       | Description                                         |*/
/*|------------------------------------------------------------------------|*/
/*|  P+ | Nov 29, 99 | Last Code Generation                                |*/
/*+========================================================================+*/
import java.util.*;

public class FlightLeg
{

    private  String flightNumber_;
    public String flightNumber() { return flightNumber_; }
    public void flightNumber(String aString) { flightNumber_ = aString; }

    private  Vector seatAssignments_;
    public Vector seatAssignments() { return seatAssignments_; }
    public void seatAssignments(Vector aVector) { seatAssignments_ = aVector; }

    private  Plane plane_;
    public Plane plane() { return plane_; }
    public void plane(Plane aPlane) { plane_ = aPlane; }

    private  Airport destinationPoint_;
    public Airport destinationPoint() { return destinationPoint_; }
    public void destinationPoint(Airport anAirport) { destinationPoint_ = anAirport; }

    private  Airport departurePoint_;
    public Airport departurePoint() { return departurePoint_; }
    public void departurePoint(Airport anAirport) { departurePoint_ = anAirport; }

	private String departureDay_;
	public String departureDay() { return departureDay_; }
	public void departureDay( String aString ) { departureDay_ = aString; }

	private String arrivalDay_;
	public String arrivalDay() { return arrivalDay_; }
	public void arrivalDay( String aString ) { arrivalDay_ = aString; }

	private String departureTime_;
	public String departureTime() { return departureTime_; }
	public void departureTime( String aString ) { departureTime_ = aString; }

	private String arrivalTime_;
	public String arrivalTime() { return arrivalTime_; }
	public void arrivalTime( String aString ) { arrivalTime_ = aString; }



    FlightLeg () {
        this.initialize();
    }

    FlightLeg(String flightNumber, Plane aPlane, Airport departurePoint,
                   Airport destinationPoint, String departureDay,
                       String departureTime, String arrivalDay,
                           String arrivalTime) {
        this();
        this.flightNumber(flightNumber);
        this.plane(aPlane);
        this.departurePoint(departurePoint);
        this.destinationPoint(destinationPoint);
        this.departureDay(departureDay);
        this.arrivalDay(arrivalDay);
        this.departureTime(departureTime);
        this.arrivalTime(arrivalTime);
   }

    private void initialize() {
        this.flightNumber("");
        this.seatAssignments(new Vector());
        this.plane(new Plane());
        this.departurePoint(new Airport());
        this.destinationPoint(new Airport());
        this.departureDay("");
        this.arrivalDay("");
        this.departureTime("");
        this.arrivalTime("");
    }

    public  Vector passengers() {
        Vector TempValue = null;
        return TempValue;
    }

    public  Vector availableSeats() {
        Vector TempValue = null;
        return TempValue;
    }

    public String asString() {
        String theString = new String();
        theString = " " + this.flightNumber() +
                    "                                                    " + this.departurePoint().name() +
                    " " + this.departureDay() +
                    " " + this.departureTime() +
                    "                       " + this.destinationPoint().name() +
                    " " + this.arrivalDay() +
                    " " + this.arrivalTime();
        return theString;
    }


    public void addSeatAssignment(Passenger aPassenger, Seat aSeat) {
        this.seatAssignments().addElement(new SeatAssignment(aPassenger, aSeat));
    }

}

