/*+========================================================================+*/
/*| [FBN ARS     ], Copyright [1999] [FBN Software]  All Rights Reserved.  |*/
/*|------------------------------------------------------------------------|*/
/*| NOTE: This software contains valuable trade secrets and proprietary    |*/
/*| information of [FBN Software] and is protected by law. It may not be   |*/
/*| copied or distributed in any form or medium, disclosed to third        |*/
/*| parties, reverse engineered or used in any manner without prior        |*/
/*| written authorization from [FBN Software].                             |*/
/*|------------------------------------------------------------------------|*/
/*| FILE: FlyByNiteReservationSystem.java                                  |*/
/*|------------------------------------------------------------------------|*/
/*| MODULE:                                                                |*/
/*|------------------------------------------------------------------------|*/
/*| Who | Date       | Description                                         |*/
/*|------------------------------------------------------------------------|*/
/*|  P+ | Nov 29, 99 | Last Code Generation                                |*/
/*+========================================================================+*/
import java.util.*;

public class FlyByNiteReservationSystem
{

    private  Vector flightLegs_;
    public Vector flightLegs() { return flightLegs_; }
    public void flightLegs(Vector aVector) { flightLegs_ = aVector; }

    private  Vector passengers_;
    public Vector passengers() { return passengers_; }
    public void passengers(Vector aVector) { passengers_ = aVector; }

    private  Hashtable airports_;
    public Hashtable airports() { return airports_; }
    public void airports(Hashtable aHashtable) { airports_ = aHashtable; }

	private Airline airline_;
	public Airline airline() { return airline_; }
	public void airline( Airline anAirline ) { airline_ = anAirline; }

    FlyByNiteReservationSystem () {
        this.initialize();
    }

    private void initialize() {
        this.flightLegs(new Vector());
        this.passengers(new Vector());
        this.airports (new Hashtable());
        this.airline(new Airline());

        this.loadAirports();
        this.loadFlightLegs();

    }

    public Airport airportWithName(String theAirport) {
        return (Airport) this.airports().get(theAirport);
    }

    public  void reserveSeat(FlightLeg aFlightLeg,Passenger aPassenger, Seat aSeat)
    {
    }

    public  Vector getFlightLegList(Airport departurePoint, Airport destinationPoint, Date travelDate)
    {
        Vector TempValue = null;

        return TempValue;
    }

    public void loadAirports() {
        this.airports().put("LAX", new Airport("LAX", 12.00));
        this.airports().put("TEX", new Airport("TEX", 12.00));
        this.airports().put("ORE", new Airport("ORE", 12.00));
        this.airports().put("NYC", new Airport("NYC", 12.00));
        this.airports().put("OKC", new Airport("OKC", 12.00));
        this.airports().put("MIA", new Airport("MIA", 12.00));
    }

    public void addFlightLeg(FlightLeg aFlightLeg) {
        this.flightLegs().addElement(aFlightLeg);
    }

    public void loadFlightLegs() {
        FlightLeg aFlightLeg = null;

        aFlightLeg = new FlightLeg(    "905",
                                       this.airline().planeWithName("Cyclops"),
                                       this.airportWithName("LAX"),
                                       this.airportWithName("MIA"),
                                       "12/08", "13:00", "12/08", "17:00");
       this.addFlightLeg(aFlightLeg);

        aFlightLeg = new FlightLeg(    "913",
                                       this.airline().planeWithName("Cyclops"),
                                       this.airportWithName("TEX"),
                                       this.airportWithName("MIA"),
                                       "12/08", "21:00", "12/08", "23:00");
       this.addFlightLeg(aFlightLeg);

        aFlightLeg = new FlightLeg(    "912",
                                       this.airline().planeWithName("Cyclops"),
                                       this.airportWithName("ORE"),
                                       this.airportWithName("NYC"),
                                       "12/08", "07:00", "12/08", "13:00");
       this.addFlightLeg(aFlightLeg);

        aFlightLeg = new FlightLeg(    "906",
                                       this.airline().planeWithName("Cyclops"),
                                       this.airportWithName("NYC"),
                                       this.airportWithName("LAX"),
                                       "12/08", "05:00", "12/08", "11:00");
       this.addFlightLeg(aFlightLeg);

        aFlightLeg = new FlightLeg(    "812",
                                       this.airline().planeWithName("Medusa"),
                                       this.airportWithName("NYC"),
                                       this.airportWithName("MIA"),
                                       "12/08", "11:00", "12/08", "13:00");
       this.addFlightLeg(aFlightLeg);

        aFlightLeg = new FlightLeg(    "710",
                                       this.airline().planeWithName("Medusa"),
                                       this.airportWithName("OKC"),
                                       this.airportWithName("NYC"),
                                       "12/08", "07:00", "12/08", "10:00");
       this.addFlightLeg(aFlightLeg);

        aFlightLeg = new FlightLeg(    "802",
                                       this.airline().planeWithName("Medusa"),
                                       this.airportWithName("LAX"),
                                       this.airportWithName("OKC"),
                                       "12/08", "05:00", "12/08", "08:00");
       this.addFlightLeg(aFlightLeg);

        aFlightLeg = new FlightLeg(    "911",
                                       this.airline().planeWithName("Medusa"),
                                       this.airportWithName("LAX"),
                                       this.airportWithName("TEX"),
                                       "12/08", "17:00", "12/08", "20:00");
       this.addFlightLeg(aFlightLeg);

    }

    public Airport findAirportWithName(String theAirportAbbreviation) {
        Airport theAirport = (Airport) this.airports().get(theAirportAbbreviation);
        if (theAirport == null) {
            System.out.println("oops ...");
        }
        return theAirport;
    }

    public Vector airportNames() {
        Vector theNames = new Vector();
        Enumeration theOC = this.airports().keys();
        while(theOC.hasMoreElements()) {
            String aKey = (String) theOC.nextElement();
            theNames.addElement(aKey);
        }
        return StringSorter.sort(theNames);
    }

    public Vector flightLegDays() {

        // we do not want duplicates so we use
        // a Hashtable to help us

        Hashtable theDays = new Hashtable();
        Object scrap = new Object();

        Enumeration theOC = this.flightLegs().elements();
        while (theOC.hasMoreElements()) {
            FlightLeg aFL = (FlightLeg) theOC.nextElement();
            theDays.put(aFL.departureDay(), scrap);
            theDays.put(aFL.arrivalDay(), scrap);
        }

        // now just get the keys and convert to a Vector
        Vector theDaysVector = new Vector();

        theOC = theDays.keys();
        while(theOC.hasMoreElements()) {
            String theDay = (String) theOC.nextElement();
            theDaysVector.addElement(theDay);
        }
        return StringSorter.sort(theDaysVector);
    }



}

