// package softcomputing;
import java.awt.*;
import java.util.*;
import java.lang.*;
import java.io.*;

public class Grid extends Observable{

    private Point gridSize_;
    public Point gridSize() { return gridSize_; }
    public void gridSize(Point theSize) { gridSize_ = theSize; }

    private Vector booleanElements_;
    public Vector booleanElements() { return booleanElements_; }
    public void booleanElements(Vector theElts) { booleanElements_ = theElts; }


    private Grid() {
        this.initialize();
    }

    public Grid(int xSize, int ySize) {
        this();
        this.gridSize(new Point(xSize, ySize));
    }


    private void initialize() {
        this.booleanElements(new Vector());
        System.out.println("init Grid");
    }

    public void publicize() {
        this.setChanged();
        this.notifyObservers();
    }


    public void cycleComplete() {
        this.publicize();
    }

    public void createBooleanNetwork() {

        int imax = this.gridSize().y;
        int jmax = this.gridSize().x;

        Grid aGrid = this;

        for (int i=0; i<imax; i++) {
            for (int j=0; j<jmax; j++) {
                Point aPoint = new Point(j,i);

                BooleanElement anElement = new BooleanElement();

                // set its grid location
                anElement.gridLocation(aPoint);

                // set the output value
                if (Math.random() < 0.5)
                    anElement.outputState(0);
                else
                    anElement.outputState(1);

                // set its rule
                double theRN = Math.random();
                if (Math.random() < 1.0)
                    anElement.booleanRule(Grid.toBitSet(4, (int) Math.floor(theRN * 16)));
                else
                    anElement.booleanRule(Grid.toBitSet(4,15));

                // all is cool, add it to the team
                this.booleanElements().addElement(anElement);

            }
        }

        // now connect them together

        Enumeration theElts = this.booleanElements().elements();

        BooleanElement theFirstElement = (BooleanElement) theElts.nextElement();
        BooleanElement thePreviousElement = theFirstElement;
        BooleanElement theCurrentElement = null;

        while (theElts.hasMoreElements()) {
            theCurrentElement = (BooleanElement) theElts.nextElement();
            theCurrentElement.siblingA(thePreviousElement);
            thePreviousElement.siblingB(theCurrentElement);
            thePreviousElement = theCurrentElement;
        }

        // now make the closed loop

        theCurrentElement.siblingB(theFirstElement);
        theFirstElement.siblingA(theCurrentElement);


    }

    public BooleanElement findElementAt(Point aPoint) {
        Enumeration theOC = this.booleanElements().elements();
        while (theOC.hasMoreElements()) {
            BooleanElement theBE = (BooleanElement) theOC.nextElement();
            if (theBE.gridLocation().equals( aPoint))
                return theBE;
        }
        return null;
    }



    // this should really be in BitSet but Java wouldnt
    // let me subclass it ...... ;-(

    public static BitSet toBitSet(int bits, int aNumber) {

        BitSet theSet = new BitSet(bits);

        for (int i=0; i<bits; i++) {
            int workArea = aNumber >> i;
            if ((workArea & 0x00000001) == 1)
                theSet.set(i);
            else
               theSet.clear(i);
        }

        return theSet;
    }
}
