import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import java.net.*;
import java.awt.image.*;
import java.awt.image.MemoryImageSource;

class GridTestView extends View implements ActionListener,
                                          WindowListener,
                                          Observer {

    private GridTest gridTest_;
    public GridTest gridTest() { return gridTest_; }
    public void gridTest(GridTest aBN) { gridTest_ = aBN; }

    private GridView gridView_;
    public GridView gridView(){ return gridView_; }
    public void gridview(GridView aGV) { gridView_ = aGV; }

    GridTestView(String windowName){
        super(windowName);
        this.initialize();
    }

    public static void main(String argv[]){
        System.out.println(" starting ");
        GridTestView theGridTestView =
                          new GridTestView("Kauffman Boolean Network K=2");
        theGridTestView.show();
    }

    private void initialize(){

        this.addWindowListener(this);

        MenuBar aMenuBar = new MenuBar();

        Menu aMenu = new Menu("File");

        MenuItem aMenuItem = new MenuItem("Open");
        aMenuItem.addActionListener(this);
        aMenuItem.setActionCommand("OPEN");
        aMenu.add(aMenuItem);

        aMenuItem = new MenuItem("Exit");
        aMenuItem.addActionListener(this);
        aMenuItem.setActionCommand("EXIT");
        aMenu.add(aMenuItem);

        aMenuBar.add(aMenu);

        this.setMenuBar(aMenuBar);

        // get the matrix width and height from the config file
        int widthM  = new Integer(Configuration.instance().valueOf("WIDTH")).intValue();
        int heightM = new Integer(Configuration.instance().valueOf("HEIGHT")).intValue();

        // get the canvas width and height from the config file
        int widthC  = new Integer(Configuration.instance().valueOf("CANVASWIDTH")).intValue();
        int heightC = new Integer(Configuration.instance().valueOf("CANVASHEIGHT")).intValue();


        this.gridTest(new GridTest());
        Grid theGrid = new Grid(widthM, heightM);
        this.gridTest().grid(theGrid);

        GridView aGV = new GridView(theGrid);

        aGV.setSize(widthC,heightC);
        aGV.setLocation(60,60);
        this.add(aGV);
        this.gridview(aGV);


        this.hookUpObservers();

        this.resize(widthC+100,heightC+100);
    }

    public void actionPerformed(ActionEvent e){
        if(e.getActionCommand() == "OPEN"){
                this.open();
                this.repaint();
        }

        if(e.getActionCommand() == "EXIT"){
            this.dispose();
            System.exit(0);
        }
    }

    public void hookUpObservers(){
        this.gridTest().addObserver(this);
    }

    public void open() {
        this.gridView().initializeGraphics();
        this.gridView().showIt();
        this.gridTest().startTheEngine();
    }

    public void update(Graphics g) { paint(g); }

    public void update(Observable obs, Object o) {
        this.repaint();
    }

   public boolean handleEvent(Event e) {
      if (e.id == Event.WINDOW_DESTROY)
      {
         this.hide();
         this.dispose();
         System.exit(0);
      }
      return true;
   }
    public void windowActivated(WindowEvent e){}

    public void windowClosed(WindowEvent e){}

    public void windowClosing(WindowEvent e){
        this.gridTest().done(true);
        try { Thread.sleep(2000); }
        catch(InterruptedException ie){}
        this.dispose();
        System.exit(0);

    }

    public void windowOpened(WindowEvent e){}

    public void windowDeactivated(WindowEvent e){}

    public void windowIconified(WindowEvent e){}

    public void windowDeiconified(WindowEvent e){}


}
