import java.util.*;

class NorthLeftLane extends Lane {
    NorthLeftLane(TrafficLiteController tlc){
        super(tlc);
        RegularLightBox aRLB = new RegularLightBox();
        this.lightBox( aRLB );
        this.lightBox().addObserver(this);
    }
    public void sensorActivated(){
        this.greenRequest( new GreenRequest() );
    }
    public void setConflicts(){
        this.conflictingLanes().addElement( this.trafficLiteController().getLane( "WestThruLane" ) );
        this.conflictingLanes().addElement( this.trafficLiteController().getLane( "WestLeftLane" ) );
        this.conflictingLanes().addElement( this.trafficLiteController().getLane( "EastThruLane" ) );
        this.conflictingLanes().addElement( this.trafficLiteController().getLane( "EastLeftLane" ) );
        this.conflictingLanes().addElement( this.trafficLiteController().getLane( "SouthThruLane" ) );
        this.conflictingLanes().addElement( this.trafficLiteController().getLane( "EastPedLane" ) );
        this.conflictingLanes().addElement( this.trafficLiteController().getLane( "NorthPedLane" ) );
    }
	public void update(Observable obs, Object o){
	    if( ((String) o).equals("resetGreenRequest")){
	        this.greenRequest(null);
	        return;
	    }
		this.trafficLiteController().instructLight( "NLLight" ,(String) o);
	}
}