
import java.util.*;

public class Puzzle {
   
    /**
     *  The sides associated with this Puzzle
     */
    private Vector  sides_;
    public Vector  sides() { return sides_; }
    public void sides( Vector  aVector  ) { sides_ = aVector ; }

    /**
     *  The collection of all SideElements
     */
    private Vector sideElements_;
    public Vector sideElements() { return sideElements_; }
    public void sideElements( Vector aVector ) { sideElements_ = aVector; }
    
    public Puzzle() {
        this.initialize();
    }
    
    private void initialize() {
        int elementsPerSide = Configuration.instance().intValueOf("ELEMENTSPERSIDE");
        this.sides(new Vector());
        this.sideElements(new Vector());
        this.initPuzzleElements(elementsPerSide);
    }
    
    public void initPuzzleElements(int elementsPerSide) {
        int j=0;
        
        // first generate all the side elements
        
        int totalElements = (elementsPerSide - 1) * 4;
        for (int i=0; i<totalElements; i++) {
            SideElement anElement = new SideElement(new Integer(0)); // they will be loaded later
            this.sideElements().addElement(anElement);
        }
        
        // now assign them to positions in each side
        
        Enumeration sideElements = this.sideElements().elements();

        // do the top first
        
        Vector elementsForASide = new Vector();
        for (j=0; j<elementsPerSide; j++) {
            elementsForASide.addElement(sideElements.nextElement());
        }         
        Side topSide    = new Side ("top", elementsForASide);
        
        // now the left
        
        elementsForASide = new Vector();
        elementsForASide.addElement(topSide.firstElement());
        
        for (j=0; j<elementsPerSide-1; j++) {
            elementsForASide.addElement(sideElements.nextElement());
        }
        Side leftSide   = new Side ("left", elementsForASide);
        
        // and the right
        
        elementsForASide = new Vector();
        elementsForASide.addElement(topSide.lastElement());
        
        for (j=0; j<elementsPerSide-1; j++) {
            elementsForASide.addElement(sideElements.nextElement());
        }
        Side rightSide  = new Side ("right", elementsForASide);
        
         // and the bottom
         
        elementsForASide = new Vector();
        elementsForASide.addElement(leftSide.lastElement());
        
        for (j=0; j<elementsPerSide-2; j++) {
            elementsForASide.addElement(sideElements.nextElement());
        }
        elementsForASide.addElement(rightSide.lastElement());
        Side bottomSide = new Side ("bottom", elementsForASide);
        
        // now add them to the side collection
        
        this.sides().addElement(topSide);
        this.sides().addElement(leftSide);
        this.sides().addElement(rightSide);
        this.sides().addElement(bottomSide);
    }
    
    public Enumeration sideElementEnumerator() {
        return this.sideElements().elements();
    }
           
    public void displaySides() {
        System.out.println("Magic number = " + ((Side) this.sides().firstElement()).totalValue());
        Enumeration theOC = this.sides().elements();
        while (theOC.hasMoreElements()) {
            Side aSide = (Side) theOC.nextElement();
            System.out.println(aSide);
        }
    }
}