import java.util.*;

class SouthLeftLane extends Lane {
    SouthLeftLane(TrafficLiteController tlc){
        super(tlc);
        RegularLightBox aRLB = new RegularLightBox();
        this.lightBox( aRLB );
        this.lightBox().addObserver(this);
    }
    public void sensorActivated(){
        this.greenRequest( new GreenRequest() );
    }
    public void setConflicts(){
        this.conflictingLanes().addElement( this.trafficLiteController().getLane( "EastLeftLane" ) );
        this.conflictingLanes().addElement( this.trafficLiteController().getLane( "WestLeftLane" ) );
        this.conflictingLanes().addElement( this.trafficLiteController().getLane( "EastThruLane" ) );
        this.conflictingLanes().addElement( this.trafficLiteController().getLane( "NorthThruLane" ) );
        this.conflictingLanes().addElement( this.trafficLiteController().getLane( "WestThruLane" ) );
        this.conflictingLanes().addElement( this.trafficLiteController().getLane( "WestPedLane" ) );
        this.conflictingLanes().addElement( this.trafficLiteController().getLane( "SouthPedLane" ) );
    }

	public void update(Observable obs, Object o){
	    if( ((String) o).equals("resetGreenRequest")){
	        this.greenRequest(null);
	        return;
	    }
		this.trafficLiteController().instructLight( "SLLight" ,(String) o);
	}
}