
import java.util.*;

public class StampingMachineInspector implements Runnable  {

    /**
     *  Indicates this region is busy evolving
     */
    private boolean busy_;
    public boolean busy() { return busy_ ; }
    public void busy(boolean aBoolean) { busy_ = aBoolean ; }
    
    /**
     *  Request evolution to stop at the next breaking point
     */
    private boolean stopIsRequested_;
    public boolean stopIsRequested() { return stopIsRequested_; }
    public void stopIsRequested(boolean aBoolean) { stopIsRequested_ = aBoolean ; }
    
    /**
     *  The Thread associated with this Region
     */
    private Thread thread_;
    public Thread thread() { return thread_ ; }
    public void thread(Thread aThread) { thread_ = aThread ; }
    
	/**
	 *  The machine that this inspector is assigned to.
	 */
	private LicenseNumberStamper machineToInspect_;
	public LicenseNumberStamper machineToInspect() { return machineToInspect_; }
	public void machineToInspect( LicenseNumberStamper aLicenseNumberStamper ) { machineToInspect_ = aLicenseNumberStamper; }

    
    public StampingMachineInspector(LicenseNumberStamper machineToInspect) {
        this();
        this.machineToInspect(machineToInspect);
        this.thread().start();
    }
    
    private StampingMachineInspector() {
        this.initialize();
    }
    
    private void initialize() {
        this.stopIsRequested(false);
        this.busy(false);
        this.thread(new Thread(this));
    }
    
    public void run()  {
    
        while (!this.stopIsRequested())  {
            try  {
                Thread.sleep(10000);
            }
            catch (InterruptedException e)  {
                System.out.println("oops .. interrupted");
            }
            System.out.println("Inspection .. " + this.machineToInspect().currentPlateID());
        }
    }
    
}