import java.lang.*;
import java.util.*;

class Tape {

	/**
	 *  The categories of tapes
	 */
    public static final String CATEGORYADULT      = "Adult";
    public static final String CATEGORYCHILDREN   = "Children";
    public static final String CATEGORYOVER18     = "Over 18";
    public static final String CATEGORYREGULAR    = "Regular";
    public static final String CATEGORYNEWRELEASE = "New Release";
    public static final String CATEGORYCLASSIC    = "Classic";

	/**
	 *  The title for this tape
	 */
	private String title_;
	public String title() { return title_; }
	public void title( String aString ) { title_ = aString; }

	/**
	 *  The identifier for this tape (what is on the bar code)
	 */
	private String id_;
	public String id() { return id_; }
	public void id( String aString ) { id_ = aString; }

	/**
	 *  Normal price for this tape for a -rental duration-
	 */
	private double rentalPrice_;
	public double rentalPrice() { return rentalPrice_; }
	public void rentalPrice( double aDouble ) { rentalPrice_ = aDouble; }

	/**
	 *  Amount of time (days) customer gets tape in exchange
	 *  for paying the -rental price-
	 */
	private int rentalDuration_;
	public int rentalDuration() { return rentalDuration_; }
	public void rentalDuration( int anInt ) { rentalDuration_ = anInt; }

	/**
	 *  Amount assesed the customer for each -overdue unit-
	 *  the tape is late
	 */
	private double overduePrice_;
	public double overduePrice() { return overduePrice_; }
	public void overduePrice( double aDouble ) { overduePrice_ = aDouble; }

	/**
	 *  The customer must pay the -overdue price- for each
	 *  overdueUnit (days)
	 */
	private int overdueUnit_;
	public int overdueUnit() { return overdueUnit_; }
	public void overdueUnit( int anInt ) { overdueUnit_ = anInt; }

	/**
	 * The categories a particular tape belongs to
	 */
	 private Vector categories_;
	 public Vector categories() { return categories_; }
	 public void categories(Vector aCategory) { categories_ = aCategory; }


    Tape() {
        this.initialize();
    }
    public Tape(            String title, double rentalPrice,
                            double overduePrice, int rentalDuration,
                            int overdueUnit, String id){
       this();
       this.title(title);
       this.rentalPrice(rentalPrice);
       this.overduePrice( overduePrice );
       this.rentalDuration( rentalDuration );
       this.overdueUnit( overdueUnit );
       this.id( id);
       this.categories(new Vector());
    }

    private void initialize() {
    }

    public void addCategory(String aCategory) {
        this.categories().addElement(aCategory);
    }

    public boolean isOfCategory(String SearchCategory) {

        Enumeration theOC = this.categories().elements();
        while (theOC.hasMoreElements()) {
            String aCategory = (String) theOC.nextElement();
            if (aCategory.equals(SearchCategory)) {
                System.out.println(this.title() + " isOfCategory " + SearchCategory);
                return true;
            }
        }
        return false;
    }


}