
// better write a java program to write the C++ than just write the C++


import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import java.net.*;
import java.awt.image.*;



public class ThermostatView extends SCView implements AdjustmentListener {

	/**
	 */
	private Thermostat thermostat_;
	public Thermostat thermostat() { return thermostat_; }
	public void thermostat( Thermostat aThermostat ) { thermostat_ = aThermostat; }

    public static void main(String argv[]){

        ThermostatView theThermostatView = new ThermostatView();
        theThermostatView.show();

    }

    public ThermostatView(){
        super("Thermostat View");
        this.initialize();
    }


    private void initialize(){

        this.thermostat( new Thermostat() );

        this.setLayout(null);

        this.initMenu();

        this.initWidgets();

        this.setLocation(150,150);

        this.setSize(420,400);

        this.setResizable(false);

        this.thermostat().heater().addObserver(this);
        this.thermostat().airConditioner().addObserver(this);

        this.thermostat().startTheEngine();

    }

    public void initWidgets(){

        Label aLabel = new Label("Heat Below");
        aLabel.setSize(100,25);
        aLabel.setLocation(100,300);
        this.add(aLabel);

        aLabel = new Label("Cool Above");
        aLabel.setSize(100,25);
        aLabel.setLocation(200,300);
        this.add(aLabel);

        aLabel = new Label("00");
        aLabel.setSize(100,25);
        aLabel.setLocation(100,330);
        this.addWidget("heat below Label",aLabel);

        aLabel = new Label("00");
        aLabel.setSize(100,25);
        aLabel.setLocation(200,330);
        this.addWidget("cool above Label",aLabel);

        aLabel = new Label("Current Tempurature");
        aLabel.setSize(120,25);
        aLabel.setLocation(120,90);
        this.add(aLabel);

        aLabel = new Label("" + ((45 * 60) / 92 + 40));
        aLabel.setSize(50,25);
        aLabel.setLocation(120,120);
        this.addWidget("current tempurature Label",aLabel);

        aLabel = new Label("Air Conditioner");
        aLabel.setSize(100,25);
        aLabel.setLocation(300,65);
        this.add(aLabel);

        aLabel = new Label("Heater");
        aLabel.setSize(100,25);
        aLabel.setLocation(300,165);
        this.add(aLabel);

        Scrollbar aScrollbar = new Scrollbar(Scrollbar.VERTICAL);
        aScrollbar.setSize(25,120);
        aScrollbar.setLocation(40,80);
        aScrollbar.addAdjustmentListener(this);
        aScrollbar.setValue(45);
        this.add(aScrollbar);




        this.addWidget("heat Canvas",new HeatCanvas());
        this.thermostat().heater().addObserver( (HeatCanvas) this.getWidget("heat Canvas"));



        this.addWidget("air Canvas",new AirCanvas());
        this.thermostat().airConditioner().addObserver(  (AirCanvas) this.getWidget("air Canvas"));

        ((Label) this.getWidget("heat below Label")).setText("" + this.thermostat().heatBelowTemperature());
        ((Label) this.getWidget("cool above Label")).setText("" + this.thermostat().coolAboveTemperature());

    }
    public void adjustmentValueChanged(AdjustmentEvent ae){
        int scrollbarValue = ae.getValue();
        // that is 0 to 91, so lets scale it for 40 to 100
        int actualTemperature = (scrollbarValue * 60) / 92 + 40;
        ((Label) this.getWidget("current tempurature Label")).setText("" + actualTemperature);
        // now call the model
        this.thermostat().temperatureHasChanged(actualTemperature);
    }

   public void actionPerformed(ActionEvent e){

        String actionCommand = e.getActionCommand();
        if( actionCommand.equals("Exit") ){
            this.exit();
            return;
        }
    }
    public void initMenu(){
        MenuBar aMenuBar = new MenuBar();
            Menu aMenu = new Menu("File");
                MenuItem aMenuItem = new MenuItem("Exit");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Exit");
            aMenu.add(aMenuItem);
        aMenuBar.add(aMenu);

        this.setMenuBar(aMenuBar);
    }

    public void windowClosing(WindowEvent we){
        this.exit();
    }

    private void exit(){
        try{ Thread.sleep(500); }
        catch(InterruptedException ie){}
        this.dispose();
        System.exit(0);
    }



}
