import java.awt.event.*;
import java.awt.datatransfer.*;
import java.awt.*;
import java.util.*;
import java.io.*;

class TrafficLiteSimulatorView extends OOView implements ClipboardOwner {

	private TrafficLiteSimulator trafficLiteSimulator_;
	public TrafficLiteSimulator trafficLiteSimulator() { return trafficLiteSimulator_; }
	public void trafficLiteSimulator( TrafficLiteSimulator aTrafficLiteSimulator ) { trafficLiteSimulator_ = aTrafficLiteSimulator; }

    public Clipboard clipboard = Toolkit.getDefaultToolkit().
                                            getSystemClipboard();
    private TrafficLiteSimulatorView() {
        super("TrafficLiteSimulatorView");
        this.initialize();
    }

    public void lostOwnership(Clipboard clipboard, Transferable contents){}

    public static void main( String alf[] ) {
        System.out.println("start of main");
        TrafficLiteSimulatorView aTLSView = new TrafficLiteSimulatorView();
        aTLSView.show();
        System.out.println("end of main");
    }

    private void initialize() {

        this.trafficLiteSimulator( new TrafficLiteSimulator() );
        this.trafficLiteSimulator().trafficLiteSimulatorView(this);

        this.initGraphics();
        this.initMenu();
        this.setSize(410,450);
        this.setLocation(200,200);

        this.trafficLiteSimulator().tlcAdapter().startTheTLC();

    }
    public void initGraphics(){



      //  try{ Thread.sleep(2000); }
       // catch(InterruptedException ie){}



        VerticalLightCanvas aVerticalLight = new VerticalLightCanvas();
        aVerticalLight.setLocation(125,102);
        this.addWidget("NSLight",aVerticalLight);

        aVerticalLight = new VerticalLightCanvas();
        aVerticalLight.setLocation(165,102);
        this.addWidget("NLLight",aVerticalLight);

        aVerticalLight = new VerticalLightCanvas();
        aVerticalLight.setLocation(249,321);
        this.addWidget("SSLight",aVerticalLight);

        aVerticalLight = new VerticalLightCanvas();
        aVerticalLight.setLocation(207,321);
        this.addWidget("SLLight",aVerticalLight);

        HorizontalLightCanvas aHorizontalLight = new HorizontalLightCanvas();
        aHorizontalLight.setLocation(282,165);
        this.addWidget("ESLight",aHorizontalLight);

        aHorizontalLight = new HorizontalLightCanvas();
        aHorizontalLight.setLocation(283,205);
        this.addWidget("ELLight",aHorizontalLight);

        aHorizontalLight = new HorizontalLightCanvas();
        aHorizontalLight.setLocation(61,287);
        this.addWidget("WSLight",aHorizontalLight);

        aHorizontalLight = new HorizontalLightCanvas();
        aHorizontalLight.setLocation(60,246);
        this.addWidget("WLLight",aHorizontalLight);

        PedestrianLightCanvas aPedLight = new PedestrianLightCanvas();
        aPedLight.setLocation(74,40);
        this.addWidget("NPedLight1",aPedLight);

        aPedLight = new PedestrianLightCanvas();
        aPedLight.setLocation(283,40);
        this.addWidget("NPedLight2",aPedLight);

        aPedLight = new PedestrianLightCanvas();
        aPedLight.setLocation(74,396);
        this.addWidget("SPedLight1",aPedLight);

        aPedLight = new PedestrianLightCanvas();
        aPedLight.setLocation(281,396);
        this.addWidget("SPedLight2",aPedLight);

        aPedLight = new PedestrianLightCanvas();
        aPedLight.setLocation(356,114);
        this.addWidget("EPedLight1",aPedLight);

        aPedLight = new PedestrianLightCanvas();
        aPedLight.setLocation(356,320);
        this.addWidget("EPedLight2",aPedLight);

        aPedLight = new PedestrianLightCanvas();
        aPedLight.setLocation(0,114);
        this.addWidget("WPedLight1",aPedLight);

        aPedLight = new PedestrianLightCanvas();
        aPedLight.setLocation(0,321);
        this.addWidget("WPedLight2",aPedLight);





        PedestrianButton aButton = new PedestrianButton(this);
        aButton.setLocation(41,46);
        aButton.setActionCommand("nw");
        this.addWidget("NPedButton1",aButton);

        aButton = new PedestrianButton(this);
        aButton.setLocation(334,46);
        aButton.setActionCommand("ne");
        this.addWidget("NPedButton2",aButton);

        aButton = new PedestrianButton(this);
        aButton.setLocation(43,400);
        aButton.setActionCommand("sw");
        this.addWidget("SPedButton1",aButton);

        aButton = new PedestrianButton(this);
        aButton.setLocation(332,400);
        aButton.setActionCommand("se");
        this.addWidget("SPedButton2",aButton);

        aButton = new PedestrianButton(this);
        aButton.setLocation(365,75);
        aButton.setActionCommand("en");
        this.addWidget("EPedButton1",aButton);

        aButton = new PedestrianButton(this);
        aButton.setLocation(365,373);
        aButton.setActionCommand("es");
        this.addWidget("EPedButton2",aButton);

        aButton = new PedestrianButton(this);
        aButton.setLocation(9,76);
        aButton.setActionCommand("wn");
        this.addWidget("WPedButton1",aButton);

        aButton = new PedestrianButton(this);
        aButton.setLocation(9,373);
        aButton.setActionCommand("ws");
        this.addWidget("WPedButton2",aButton);

        SensorButton aSensorButton = new SensorButton(this);
        aSensorButton.setLocation(124,65);
        aSensorButton.setActionCommand("ns");
        this.addWidget("NSSensor",aSensorButton);

        aSensorButton = new SensorButton(this);
        aSensorButton.setLocation(168,65);
        aSensorButton.setActionCommand("nl");
        this.addWidget("NLSensor",aSensorButton);

        aSensorButton = new SensorButton(this);
        aSensorButton.setLocation(251,382);
        aSensorButton.setActionCommand("ss");
        this.addWidget("SSSensor",aSensorButton);

        aSensorButton = new SensorButton(this);
        aSensorButton.setLocation(210,382);
        aSensorButton.setActionCommand("sl");
        this.addWidget("SLSensor",aSensorButton);

        aSensorButton = new SensorButton(this);
        aSensorButton.setLocation(347,159);
        aSensorButton.setActionCommand("es");
        this.addWidget("ESSensor",aSensorButton);

        aSensorButton = new SensorButton(this);
        aSensorButton.setLocation(347,201);
        aSensorButton.setActionCommand("el");
        this.addWidget("ELSensor",aSensorButton);

        aSensorButton = new SensorButton(this);
        aSensorButton.setLocation(30,283);
        aSensorButton.setActionCommand("ws");
        this.addWidget("WSSensor",aSensorButton);

        aSensorButton = new SensorButton(this);
        aSensorButton.setLocation(30,242);
        aSensorButton.setActionCommand("wl");
        this.addWidget("WLSensor",aSensorButton);


        this.addWidget("intersection", new IntersectionCanvas());

    }
    public void initMenu(){
        MenuBar aMenuBar = new MenuBar();
            Menu aMenu = new Menu("File");
                MenuItem aMenuItem = new MenuItem("Exit");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Exit");
                aMenu.add(aMenuItem);
            aMenuBar.add(aMenu);

            aMenu = new Menu("Test");
                aMenuItem = new MenuItem("Test");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Test");
            aMenu.add(aMenuItem);

            aMenuBar.add(aMenu);
        this.setMenuBar(aMenuBar);
    }

    public void sensorButtonPressed(String actionCommand){
        this.trafficLiteSimulator().sensorButtonPressed(actionCommand);
    }
    public void pedestrianButtonPressed(String actionCommand){
        this.trafficLiteSimulator().pedestrianButtonPressed(actionCommand);
    }
/////////////////////////////////////////////////////////////////////
    public void test(){
        System.out.println("test in TLSView");

        // Remove the following line. It is only there for light demonstration
        // and to show how your TrafficLightController can communicate with the
        // TLCAdapter
       this.trafficLiteSimulator().tlcAdapter().trafficLiteController().testIt();

    }
/////////////////////////////////////////////////////////////////////
   public void actionPerformed(ActionEvent e){
        String actionCommand = e.getActionCommand();
        if( actionCommand.equals("Exit") ){
            this.exit();
            return;
        }
        if( actionCommand.equals("Test") ){
            this.test();
            return;
        }
    }
    public void windowClosing(WindowEvent we){
        this.exit();
    }
    private void exit(){
        System.out.println("closing TLSView");
        try{ Thread.sleep(500); }
        catch(InterruptedException ie){}
        this.dispose();
        System.exit(0);
    }

    public void update(String widgetName, String command){
        ((LightBoxWidget) this.getWidget(widgetName)).setState(command);
    }


}
