/*+========================================================================+*/
/*| [FBN ARS     ], Copyright [1999] [FBN Software]  All Rights Reserved.  |*/
/*|------------------------------------------------------------------------|*/
/*| NOTE: This software contains valuable trade secrets and proprietary    |*/
/*| information of [FBN Software] and is protected by law. It may not be   |*/
/*| copied or distributed in any form or medium, disclosed to third        |*/
/*| parties, reverse engineered or used in any manner without prior        |*/
/*| written authorization from [FBN Software].                             |*/
/*|------------------------------------------------------------------------|*/
/*| FILE: View.java                                                        |*/
/*|------------------------------------------------------------------------|*/
/*| MODULE:                                                                |*/
/*|------------------------------------------------------------------------|*/
/*| Who | Date       | Description                                         |*/
/*|------------------------------------------------------------------------|*/
/*|  P+ | Nov 29, 99 | Last Code Generation                                |*/
/*+========================================================================+*/
import java.util.*;
import java.awt.*;
import java.awt.event.*;

public class TravelPlansView extends SCView {

	private TravelPlanGenerator travelPlanGenerator_;
	private TravelPlanGenerator travelPlanGenerator() { return travelPlanGenerator_; }
	private void travelPlanGenerator( TravelPlanGenerator aTravelPlanGenerator ) { travelPlanGenerator_ = aTravelPlanGenerator; }

    TravelPlansView(TravelPlanGenerator theTPG) {
        super ("Fly By Night Travel Plans");
        this.travelPlanGenerator(theTPG);
        this.initialize();
    }

    private void initialize() {

        // initialize
        this.setSize(700, 500);
        this.setLocation(200, 200);
        this.initLists();
        this.initLabels();
        this.initMenu();
    }

    private void initLists(){

        Font mediumFont = new Font("Courier",Font.BOLD,14);

        List aList = new TravelPlansList(this);
        aList.setSize(600, 200);
        aList.setLocation(50,100);
        aList.setMultipleMode(false);
        aList.addItemListener(this);
        aList.setFont( mediumFont);
        this.addWidget("plans",aList);

        aList = new SeatList(this);
        aList.setSize(600, 160);
        aList.setLocation(50,320);
        aList.setMultipleMode(false);
        aList.addItemListener(this);
        aList.setFont( mediumFont);
        this.addWidget("seats",aList);


    }

    private void initLabels(){

        Font bigFont = new Font("Helvetica",Font.BOLD,20);
        Font mediumFont = new Font("Helvetica",Font.BOLD,14);
        Font smallFont = new Font("Helvetica",Font.BOLD,10);

        Label aLabel = new Label("Flight");
        aLabel.setFont( mediumFont );
        aLabel.setSize(100,32);
        aLabel.setLocation(50,60);
        this.addWidget("flight",aLabel);

        aLabel = new Label("Departure");
        aLabel.setFont( mediumFont );
        aLabel.setSize(100,32);
        aLabel.setLocation(300,60);
        this.addWidget("departure",aLabel);

        aLabel = new Label("Destination");
        aLabel.setFont( mediumFont );
        aLabel.setSize(100,32);
        aLabel.setLocation(500,60);
        this.addWidget("destination",aLabel);

    }

    private void initMenu(){
        MenuBar aMenuBar = new MenuBar();

            Menu aMenu = new Menu("File");

                MenuItem aMenuItem = new MenuItem("Exit");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Exit");
                aMenu.add(aMenuItem);

            aMenuBar.add(aMenu);

            aMenu = new Menu("Edit");

                aMenuItem = new MenuItem("Cut");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Cut");
                aMenu.add(aMenuItem);

                aMenuItem = new MenuItem("Copy");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Copy");
                aMenu.add(aMenuItem);

                aMenuItem = new MenuItem("Paste");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Paste");
                aMenu.add(aMenuItem);

            aMenuBar.add(aMenu);

            aMenu = new Menu("Sort");

                aMenuItem = new MenuItem("by Price");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("sortByPrice");
                aMenu.add(aMenuItem);


                aMenuItem = new MenuItem("by Travel Time");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("sortByTravelTime");
                aMenu.add(aMenuItem);


            aMenuBar.add(aMenu);

            /*
            aMenu = new Menu("Tool");

                aMenuItem = new MenuItem("Generate Travel Plans");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("GenerateTravelPlans");
                aMenu.add(aMenuItem);
            */

                /*
                aMenuItem = new MenuItem("URL Rankings");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("URLRankings");
                aMenu.add(aMenuItem);

            aMenuBar.add(aMenu);
                */


        this.setMenuBar(aMenuBar);

    }

    public void sortByPrice(){
       System.out.println("Sorting By Price ..");
    }

    public void sortByTravelTime(){
       System.out.println("Sorting By Travel Time ..");
    }

    public void actionPerformed(ActionEvent e){
        String command = (String) e.getActionCommand();
        if(command == "Exit"){
            this.exit();
            return;
        }
    }

    public void update(Observable obs, Object o) {
        int planCounter = 1;
        TravelPlanGenerator theTPG = (TravelPlanGenerator) obs;
        Enumeration theOC = theTPG.plans().elements();
        while (theOC.hasMoreElements()) {
            TravelPlan aTP = (TravelPlan) theOC.nextElement();
            this.addTravelPlanToList(planCounter, aTP);
            planCounter++;
        }
    }

    public void addTravelPlanToList(int theTravelPlanNumber, TravelPlan aPlan) {
        ((List) this.getWidget("plans")).add("Travel Plan - " + theTravelPlanNumber);
        Enumeration theOC = aPlan.asLines().elements();
        while(theOC.hasMoreElements()) {
            String aLine = (String) theOC.nextElement();
            ((List) this.getWidget("plans")).add(aLine);
        }
    }

    public void flightLegSelected(String theLeg) {
        this.travelPlanGenerator().flightLegSelected(theLeg);
    }

    public void seatSelected() {
    }

    public void windowClosing(WindowEvent e){
        this.exit();
    }

    private void exit(){
        this.hide();
    }

}

