import java.util.*;
import java.lang.*;
import java.awt.*;

class TravelerFrame {

	/**
	 *  The Track associated with this TraverlerFrame
	 */
	private Track track_;
	public Track track() { return track_; }
	public void track( Track aTrack ) { track_ = aTrack; }

	/**
	 *  The position that the image associated with this
	 *  Frame will be drawn
	 */
	private Point position_;
	public Point position() { return position_; }
	public void position( Point aPoint ) { position_ = aPoint; }

	/**
	 *  The image set for this TravelerFrame
	 */
	private Image image_;
	public Image image() { return image_; }
	public void image( Image anImage ) { image_ = anImage; }

	/**
	 *  Angle as a 3 digit string e.g.  -310-
	 */
	private String angle_;
	public String angle() { return angle_; }
	public void angle( String aString ) { angle_ = aString; }

	/**
	 *  this four sided polygon represents the area enclosed by the
	 *  graphical car itself, not the 40 X 40 rectangular image.
	 */
	private Polygon polygon_;
	public Polygon polygon() { return polygon_; }
	public void polygon( Polygon aPolygon ) { polygon_ = aPolygon; }

    TravelerFrame() {
        this.initialize();
    }

    TravelerFrame(Point aPosition, Track aTrack) {
        this();
        this.position(aPosition);
        this.track(aTrack);
        this.image(null);
    }

    private void initialize() {
        this.position(new Point(0,0));
        this.track(null);
    }

public void createPolygon(){
    double theta;
    int x0, y0;

    theta = Double.valueOf(this.angle()).doubleValue();
    x0 = this.position().x;
    y0 = this.position().y;


    double thetaC1 = (theta - 36.0) % 180.0;
    double thetaC2 = (theta + 36.0) % 180.0;

    int xValues[] = new int[4];
    int yValues[] = new int[4];

    xValues[0] = (int) ((double) x0 + Math.abs(18.0*Math.sin(thetaC1)));
    xValues[1] = (int) ((double) x0 - Math.abs(18.0*Math.sin(thetaC1)));
    xValues[2] = (int) ((double) x0 + Math.abs(18.0*Math.sin(thetaC2)));
    xValues[3] = (int) ((double) x0 - Math.abs(18.0*Math.sin(thetaC2)));

    yValues[0] = (int) ((double) y0 + Math.abs(18.0*Math.cos(thetaC1)));
    yValues[1] = (int) ((double) y0 - Math.abs(18.0*Math.cos(thetaC1)));
    yValues[2] = (int) ((double) y0 + Math.abs(18.0*Math.cos(thetaC2)));
    yValues[3] = (int) ((double) y0 - Math.abs(18.0*Math.cos(thetaC2)));

    Polygon aPolygon = new Polygon(xValues,yValues,4);

    this.polygon( aPolygon );

}

}

