import java.lang.*;
import java.util.*;

class VendingMachine {

	/*
	*/
	private CoinReturnButton coinReturnButton_;
	public CoinReturnButton coinReturnButton() { return coinReturnButton_; }
	public void coinReturnButton( CoinReturnButton aCoinReturnButton ) { coinReturnButton_ = aCoinReturnButton; }

	/*
	*/
	private MoneySlot moneySlot_;
	public MoneySlot moneySlot() { return moneySlot_; }
	public void moneySlot( MoneySlot aMoneySlot ) { moneySlot_ = aMoneySlot; }

	/*
	*/
	//private Dispenser dispenser_;
	//public Dispenser dispenser() { return dispenser_; }
	//public void dispenser( Dispenser aDispenser ) { dispenser_ = aDispenser; }

	/**
	 *  Contains the dispensers for this VendingMachine.
	 *  Dispensers are accessed by name
	 */
	private Hashtable dispensers_;
	public Hashtable dispensers() { return dispensers_; }
	public void dispensers( Hashtable anHashtable ) { dispensers_ = anHashtable; }


	VendingMachine() {
	    this.initialize();
	}

	private void initialize() {

	    this.moneySlot(new MoneySlot());
	    this.coinReturnButton(new CoinReturnButton());

	    // now the tricky hooks

	    this.moneySlot().coinBucket (this.coinReturnButton().coinBucket());
	    this.moneySlot().coinCounter().coinBucket(this.moneySlot().coinBucket());
        this.coinReturnButton().coinBucket().addObserver(this.moneySlot().coinCounter());

	    // and the dispensers

	    this.dispensers(new Hashtable());

	    // add the first dispenser

	    Dispenser aDispenser = new Dispenser("Coke");
        aDispenser.coinCounter(this.moneySlot().coinCounter());
	    this.dispensers().put(aDispenser.name(),aDispenser);

	    // add the second dispenser

	    aDispenser = new Dispenser("Pepsi");
        aDispenser.coinCounter(this.moneySlot().coinCounter());
	    this.dispensers().put(aDispenser.name(),aDispenser);


	}

	public void powerOn() {
	}

	public Vector dispenserNames() {

	    Vector theNames = new Vector();
	    Enumeration theOC = this.dispensers().keys();
	    while (theOC.hasMoreElements()) {
	        String aName = (String) theOC.nextElement();
	        theNames.addElement(aName);
	    }
	    return theNames;
	}

	public Dispenser dispenser(String aDispenserName) {
	    return ((Dispenser) this.dispensers().get(aDispenserName));
	}

	public void dispense(String aDispenserName) {
	    Dispenser theDispenser = (Dispenser) this.dispensers().get(aDispenserName);
	    theDispenser.dispenseButtonPressed();
	}

}
