
import java.lang.*;
import java.util.*;

class VideoStore {

	/**
	 *  The customers associated with this store
	 */
	private Hashtable customers_;
	public Hashtable customers() { return customers_; }
	public void customers( Hashtable anHT ) { customers_ = anHT; }

	/**
	 *  In charge of computing prices for purchases
	 */
	private PriceCalculator priceCalculator_;
	public PriceCalculator priceCalculator() { return priceCalculator_; }
	public void priceCalculator( PriceCalculator aPriceCalculator ) { priceCalculator_ = aPriceCalculator; }

	/**
	 *  The tapes available in this VideoStore
	 */
	private TapeLibrary tapeLibrary_;
	public TapeLibrary tapeLibrary() { return tapeLibrary_; }
	public void tapeLibrary( TapeLibrary aTapeLibrary ) { tapeLibrary_ = aTapeLibrary; }

	/**
	 *  The cashiers working in this store
	 */
	private Hashtable cashiers_;
	public Hashtable cashiers() { return cashiers_; }
	public void cashiers( Hashtable anHT ) { cashiers_ = anHT; }

	VideoStore() {
	    this.initialize();
	}

	private void initialize() {
	    this.customers(new Hashtable());

            Customer aCustomer = new Customer("1402","Fred","22 Pine");
            this.customers().put(aCustomer.id(),aCustomer);
            aCustomer = new Customer("1403","Fred","22 Pine");
            this.customers().put(aCustomer.id(),aCustomer);
            aCustomer = new Customer("1404","Sally","22 Pine");
            this.customers().put(aCustomer.id(),aCustomer);
            aCustomer = new Customer("1405","Mike","22 Pine");
            this.customers().put(aCustomer.id(),aCustomer);
            aCustomer = new Customer("1406","Jennifer","22 Pine");
            this.customers().put(aCustomer.id(),aCustomer);
            aCustomer = new Customer("1407","Luke","22 Pine");
            this.customers().put(aCustomer.id(),aCustomer);

	    this.priceCalculator(new PriceCalculator());
	    this.tapeLibrary(new TapeLibrary());
	    this.cashiers(new Hashtable());
	}

	public Enumeration promotionNames() {
	    return this.priceCalculator().promotionNames();
	}

	public Enumeration tapes() {
	    return this.tapeLibrary().tapes().elements();
	}

    public double calculatePrice( Vector tapeIDs, Vector promoNames, String customerID ){
        Vector tapes = new Vector();
        Enumeration enum = tapeIDs.elements();
        while( enum.hasMoreElements() ){
            String aTapeID = (String) enum.nextElement();
            tapes.addElement( this.tapeLibrary().getTape(aTapeID) );
        }
        Customer customer = (Customer) this.customers().get( customerID );
        if (customer == null) return 0.00;

        Basket thisCustomersBasket = new Basket();
        thisCustomersBasket.tapes( tapes );
        customer.basket( thisCustomersBasket );

        return this.priceCalculator().calculatePrice( promoNames, customer );
    }

}
