
import java.awt.*;
import java.awt.event.*;
import java.util.*;

class OOView extends Frame implements Observer,
                                      WindowListener,
                                      ActionListener {

    private Hashtable widgets_;
    private void widgets(Hashtable aHashtable) { widgets_ = aHashtable; }
    protected Hashtable widgets()                { return widgets_;       }

    private Hashtable subViews_;
    private void subViews(Hashtable aHashtable) { subViews_ = aHashtable; }
    protected Hashtable subViews()                { return subViews_;       }

    OOView(String s){
        super(s);
        this.initialize();
    }
    private void initialize(){

        this.setLayout(null);

        this.widgets( new Hashtable() );
        this.subViews( new Hashtable() );

        this.addWindowListener(this);

    }

    protected void addWidget(String aName, Component c){
        this.add(c);
        this.widgets().put(aName, c);
    }
    protected Component getWidget(String aName){
        return (Component) this.widgets().get(aName);
    }
    protected void addSubView(String aName, OOView v){
        this.subViews().put(aName, v);
    }
    protected Component getSubView(String aName){
        return (OOView) this.subViews().get(aName);
    }

    // support Observer interface
    public void update(Observable obs, Object o){}

    // support ActionListener interface
    public void actionPerformed(ActionEvent e){}

    // support WindowListener interface
    public void windowActivated(WindowEvent e){}
    public void windowClosed(WindowEvent e){}
    public void windowClosing(WindowEvent e){}
    public void windowOpened(WindowEvent e){}
    public void windowDeactivated(WindowEvent e){}
    public void windowIconified(WindowEvent e){}
    public void windowDeiconified(WindowEvent e){}

}
