import java.awt.*;
import java.util.*;
import java.awt.event.*;

class AccountView extends Frame implements Observer ,
                                           WindowListener ,
                                           ActionListener {

    private BankView bankView_;
    private void bankView(BankView aBankView){ bankView_ = aBankView; }
    private BankView bankView(){ return bankView_; }

    private Account account_;
    private void account(Account aAccount){ account_ = aAccount; }
    private Account account(){ return account_; }

    private Label balanceLabel_;
    private void balanceLabel(Label aLabel){ balanceLabel_ = aLabel; }
    private Label balanceLabel(){ return balanceLabel_; }

    private TextField accountField_;
    private void accountField(TextField aTextField){ accountField_ = aTextField; }
    private TextField accountField(){ return accountField_; }

    public static void main(String alf[]){
        BankView bv = new BankView(new Bank());
        bv.show();
    }

    AccountView( BankView aBankView ){
        super( "Account View" );
        this.bankView( aBankView );
        this.initialize();
    }

    private void initialize(){

        this.setLayout(null);

        this.addWindowListener(this);

        this.balanceLabel( new Label() );
        this.balanceLabel().setSize( 150,20 );
        this.balanceLabel().setLocation( 10,100 );
        this.add( this.balanceLabel() );

        this.accountField( new TextField() );
        this.accountField().addActionListener(this);
        this.accountField().setSize( 150,20 );
        this.accountField().setLocation( 10,50 );
        this.add( this.accountField() );

        Label aLabel = new Label("Account Number");
        aLabel.setSize(150,20);
        aLabel.setLocation(10,30);
        this.add( aLabel );

        aLabel = new Label("Current Balance");
        aLabel.setSize(150,20);
        aLabel.setLocation(10,80);
        this.add( aLabel );


        this.setSize(170,125);
        this.setLocation(300,300);
    }

    public void windowClosing(WindowEvent we){
        this.exit();
    }

    private void exit(){
        System.out.println("closing AccountView");
        try{ Thread.sleep(1000); }
        catch(InterruptedException ie){}
        this.account().deleteObserver(this);
        this.dispose();
    }

    // support Observer interface
    public void update(Observable obs, Object o){
        this.balanceLabel().setText(
                    String.valueOf(((Account) obs).balance() ));
    }

    // support ActionListener interface
    public void actionPerformed(ActionEvent e){
        this.account( this.bankView().getAccount(e.getActionCommand()));
        if( this.account().id() == null ){
            this.balanceLabel().setText("Bad Account ID");
            return;
        }
        this.account().addObserver(this);
        this.balanceLabel().setText(
                    String.valueOf(this.account().balance() ));

    }

    // support WindowListener interface
    public void windowActivated(WindowEvent e){}
    public void windowClosed(WindowEvent e){}
    //public void windowClosing(WindowEvent e){}
    public void windowOpened(WindowEvent e){}
    public void windowDeactivated(WindowEvent e){}
    public void windowIconified(WindowEvent e){}
    public void windowDeiconified(WindowEvent e){}

}
