import java.awt.*;
import java.util.*;
import java.awt.event.*;

class BankView extends Frame implements Observer ,
                                        WindowListener ,
                                        ActionListener {

    private Bank bank_;
    private void bank(Bank aBank){ bank_ = aBank; }
    private Bank bank(){ return bank_; }

    private List currentList_;
    private void currentList(List aList){ currentList_ = aList; }
    private List currentList(){ return currentList_; }

    private List processedList_;
    private void processedList(List aList){ processedList_ = aList; }
    private List processedList(){ return processedList_; }

    private Label numberOfTransLabel_;
    private void numberOfTransLabel(Label aLabel){ numberOfTransLabel_ = aLabel; }
    private Label numberOfTransLabel(){ return numberOfTransLabel_; }

    private Label cashFlowLabel_;
    private void cashFlowLabel(Label aLabel){ cashFlowLabel_ = aLabel; }
    private Label cashFlowLabel(){ return cashFlowLabel_; }

    public static void main(String alf[]){
        BankView bv = new BankView(new Bank());
        bv.show();
    }

    BankView(Bank aBank){
        super( "Bank View" );
        this.bank(aBank);
        this.initialize();
    }

    private void initialize(){

        this.setLayout(null);

        this.addWindowListener(this);

        this.bank().addObserver(this);

        this.currentList( new List() );
        this.currentList().setSize( 550,95 );
        this.currentList().setLocation( 10,110 );
        this.add( this.currentList() );

        this.processedList( new List() );
        this.processedList().setSize( 550,95 );
        this.processedList().setLocation( 10,215 );
        this.add( this.processedList() );

        this.numberOfTransLabel( new Label() );
        this.numberOfTransLabel().setSize( 150,20 );
        this.numberOfTransLabel().setLocation( 200,80 );
        this.add( this.numberOfTransLabel() );

        this.cashFlowLabel( new Label() );
        this.cashFlowLabel().setSize( 150,20 );
        this.cashFlowLabel().setLocation( 20,80 );
        this.add( this.cashFlowLabel() );

        Label aLabel = new Label("Cash Flow");
        aLabel.setSize(150,20);
        aLabel.setLocation(20,50);
        this.add( aLabel );

        aLabel = new Label("Number of Transactions");
        aLabel.setSize(150,20);
        aLabel.setLocation(200,50);
        this.add( aLabel );


        MenuBar aMenuBar = new MenuBar();

        Menu aMenu = new Menu("File");
        MenuItem aMenuItem = new MenuItem("Exit");
        aMenuItem.addActionListener(this);
        aMenuItem.setActionCommand("Exit");
        aMenu.add(aMenuItem);
        aMenuBar.add(aMenu);

        aMenu = new Menu("Edit");
        aMenuItem = new MenuItem("Cut");
        aMenuItem.disable();
        aMenu.add(aMenuItem);
        aMenuItem = new MenuItem("Copy");
        aMenuItem.disable();
        aMenu.add(aMenuItem);
        aMenuItem = new MenuItem("Paste");
        aMenuItem.disable();
        aMenu.add(aMenuItem);
        aMenuBar.add(aMenu);


        aMenu = new Menu("Action");
        aMenuItem = new MenuItem("Process Transactions");
        aMenuItem.addActionListener(this);
        aMenuItem.setActionCommand("Process Transactions");
        aMenu.add(aMenuItem);
        aMenuItem = new MenuItem("Process Log");
        aMenuItem.addActionListener(this);
        aMenuItem.setActionCommand("Process Log");
        aMenu.add(aMenuItem);
        aMenuItem = new MenuItem("View Account");
        aMenuItem.addActionListener(this);
        aMenuItem.setActionCommand("View Account");
        aMenu.add(aMenuItem);
        aMenuBar.add(aMenu);

        this.setMenuBar(aMenuBar);


        this.setSize(570,320);
        this.setLocation(200,200);

    }

    public void windowClosing(WindowEvent we){
        this.exit();
    }
    private void exit(){
        System.out.println("closing BankView");
        try{ Thread.sleep(1000); }
        catch(InterruptedException ie){}
        System.exit(0);
    }
    private void viewAccount(){
        (new AccountView(this)).show();
    }

    public Account getAccount(String accountID) {
        return this.bank().getAccount(accountID);
    }

    public void processLog(){
        this.processedList().removeAll();

        Vector v = this.bank().processLog();
        Enumeration e = v.elements();
        while( e.hasMoreElements() ){
            this.processedList().addItem( (String) e.nextElement() );
        }
    }


    // support Observer interface
    public void update(Observable obs, Object o){
        this.currentList().addItem((String) o);
        this.numberOfTransLabel().setText("" + this.bank().numberOfTransactions());
        this.cashFlowLabel().setText(""+ this.bank().cashFlow());
    }

    // support ActionListener interface
    public void actionPerformed(ActionEvent e){
        String s = e.getActionCommand();
        if(s == "Exit"){
            this.exit();
            return;
        }
        if(s == "Process Transactions"){
            this.bank().processTransactions();
            return;
        }
        if(s == "Process Log"){
            this.processLog();
            return;
        }
        if(s == "View Account"){
            this.viewAccount();
            return;
        }
    }

    // support WindowListener interface
    public void windowActivated(WindowEvent e){}
    public void windowClosed(WindowEvent e){}
    //public void windowClosing(WindowEvent e){}
    public void windowOpened(WindowEvent e){}
    public void windowDeactivated(WindowEvent e){}
    public void windowIconified(WindowEvent e){}
    public void windowDeiconified(WindowEvent e){}

}
