import java.lang.*;
import java.util.*;

abstract class Transaction  {

    private Account account_;
    public Account account() { return account_; }
    public void account(Account anAcct) { account_ = anAcct; }

    private double amount_;
    public double amount() { return amount_; }
    public void amount(double anAmount) { amount_ = anAmount; }

    private Date timestamp_;
    public Date timestamp() { return timestamp_; }
    public void timestamp(Date aDate) { timestamp_ = aDate; }


    Transaction() {
        this.initialize();
    }
    public String toString(){
        String output = "CustomerName="    + this.customerName() +
                        "  Amount="       + this.amount() +
                        "  Date="         + this.timestamp() ;
        return output;
    }

    private void initialize() {
    }

    public String customerName() {
        return this.account().customerName();
    }

    public void updateAccount() {
       double balance = this.account().balance();
       double adjustment = this.adjustBalance( balance,this.amount() );
       this.account().balance(balance + this.amount() + adjustment );
    }

    public int compare(Transaction aTransaction){
        String aString = this.customerName() +
                                    this.timestamp().getTime();
        String bString = aTransaction.customerName() +
                            aTransaction.timestamp().getTime();
        return aString.compareTo( bString );
    }

    abstract double adjustBalance( double balance, double amount );


}
