import java.lang.*;
import java.util.*;

class TransactionStore {

    private Bank bank_;
    private void bank(Bank aBank){ bank_ = aBank; }
    private Bank bank(){ return bank_; }

    private Vector transactions_;
    public Vector transactions() { return transactions_; }
    public void transactions(Vector theTrans) { transactions_ = theTrans; }

    private Enumeration enumeration_;
    public Enumeration enumeration() { return enumeration_; }
    public void enumeration(Enumeration anE) { enumeration_ = anE; }


    TransactionStore(Bank aBank) {
        this.bank(aBank);
        this.initialize();
    }

    private void initialize() {

        Account a = (Account) this.bank().getAccount("100");
        Account b = (Account) this.bank().getAccount("101");

        this.transactions(new Vector());

        Vector theTrans = this.transactions();

        theTrans.addElement(new ReadyTellerTransaction (a, -20.0, new Date()));
        this.pause();
        theTrans.addElement(new MailTransaction        (a, +120.0,new Date()));
        this.pause();
        theTrans.addElement(new ReadyTellerTransaction (b, +40.0, new Date()));
        this.pause();
        theTrans.addElement(new ReadyTellerTransaction (b, -20.0, new Date()));
        this.pause();
        theTrans.addElement(new PersonalTransaction    (a, +100.0,new Date()));
        this.pause();
        theTrans.addElement(new PersonalTransaction    (a, +100.0,new Date()));
        this.pause();
        theTrans.addElement(new PersonalTransaction    (b, +99.99,new Date()));
        this.pause();
        this.enumeration(theTrans.elements());
    }

    public void pause(){
        try{Thread.sleep(1050);}
        catch(InterruptedException e){}
    }

    public synchronized void handleTransaction( Transaction t ){
        this.bank().processTransaction(t);
    }
    public Transaction getNext() {
        if (this.enumeration().hasMoreElements()) {
            return ((Transaction) this.enumeration().nextElement());
        }
        else { return null;}
    }

}
