/*

Here is the Combiner class that Tom and I made to help with the video pricer problem.
it implements Enumeration which means that it defines two methods:
        boolean hasMoreElements()
        Object nextElement()

instance method combine(Vector,int) is what you use to get the enumeration.

each element returned by the nextElement() method of this

enumeration will be a Vector that is a subset of the Vector passed to combine() and

is the size of the int passed to combine.

This algorithm was challenging for me (Jay) and the code is not as

elegant as usual.



*/

import java.util.Enumeration;
import java.util.Vector;

public class Combiner implements Enumeration {

    private int i;
    private int j;

    private int sizeOfVector;
    private int sizeOfSubsets;
    private int currentCombo[];
    private int swapCombo[];
    private Vector originalVector;

    public Combiner(){
        this.initialize();
    }
    private void initialize(){
        sizeOfVector = 0;
        sizeOfSubsets = 0;
        originalVector = new Vector();
        currentCombo = new int[10];
    }

    //  combine(Vector,int) returns an enumeration
    //  on the set of all subsets of
    //  of size sizeOfSubset contained in v.
    public Enumeration combine(Vector v, int subsetSize){

        originalVector = v;
        sizeOfSubsets = subsetSize;
        sizeOfVector = originalVector.size();
        currentCombo = new int[sizeOfSubsets + 1];
        j=1;
        i=1;

        currentCombo[0] = -1;

        for( int ii=1; ii<= sizeOfSubsets; ii++ ){
            currentCombo[ii] = ii;
        }

        swapCombo = currentCombo;

        if(v.size() <= 1){
            this.j = 0;
        }

        return this;



    }
    private void generateNextCombo(){

        j = sizeOfSubsets;
        while( currentCombo[j] == sizeOfVector - sizeOfSubsets + j ){

            j--;

        }
        currentCombo[j]++;
        for(int ii=j+1;ii<=sizeOfSubsets;ii++){

            currentCombo[ii] = currentCombo[ii-1] + 1;

        }
    }


    private Object convertComboArrayToVector(){
        Vector returnVector = new Vector();
        for(int ii = 1; ii <= sizeOfSubsets; ii++ ){
            returnVector.addElement(originalVector.elementAt(swapCombo[ii]-1));
        }
        swapCombo = currentCombo;


        return returnVector;


    }
    public boolean hasMoreElements(){
        return (j)!=0;
    }
    public Object nextElement(){
        this.generateNextCombo();
        return this.convertComboArrayToVector();
    }
}