import java.util.*;
import java.awt.*;
import java.awt.event.*;

class IntersectionCanvas extends Canvas implements Runnable {

    public Image theImage;
    private Graphics temporaryGraphics;

	/**
	 *  The VisibleCars associated with this canvas
	 */
	private Vector visibleCars_;
	public Vector visibleCars() { return visibleCars_; }
	public void visibleCars( Vector aVector ) { visibleCars_ = aVector; }

    IntersectionCanvas(){
        this.initialize();
    }

    private void initialize( ){

        CarImageFinder.instance(); // force images to be loaded

        MediaTracker mt = new MediaTracker(this);

        this.theImage = Toolkit.getDefaultToolkit().getImage("blankintersection01.GIF");
        mt.addImage(this.theImage,0);

        Enumeration theOC = CarImageFinder.instance().elements();

        // now wait for all the car images
        int i = 0;
        while(theOC.hasMoreElements()) {
            Image anImage = (Image) theOC.nextElement();
            mt.addImage(anImage, i);
            i++;
        }

        try {
            mt.waitForAll();
        }
        catch (InterruptedException e) {}

        this.setLocation(0,40);
        this.setSize(400,400);
        this.visibleCars(new Vector());
    }

    public void addVisibleCar(VisibleCar aVC) {
        this.visibleCars().addElement(aVC);
    }


    public void paint (Graphics g) {
            g.drawImage(this.theImage, 0,0,this);
            Enumeration theOC = this.visibleCars().elements();
            while (theOC.hasMoreElements()) {
                VisibleCar theVC = (VisibleCar) theOC.nextElement();
                Image theImage = theVC.currentTravelerFrame().image();
                int xPos = theVC.currentTravelerFrame().position().x;
                int yPos = theVC.currentTravelerFrame().position().y;
             //   System.out.println("image = " + theImage + "  x = " + xPos + "  y = " + yPos);
                g.drawImage(theImage, xPos, yPos, this);
            }
            this.visibleCars(new Vector());
    }

    public void update(Graphics g) {
        this.temporaryGraphics = g ;
        (new Thread(this)).start();
        try{ Thread.sleep(200); }
        catch(InterruptedException ie){}
      //  paint(g);


    }
    public void run(){
       // System.out.println("run in intersection canvas");
        this.paint(this.temporaryGraphics);
      //  this.temporaryGraphics = null;
    }

}
