
import java.util.*;
import java.lang.*;
import java.awt.*;

class VisibleCar extends Canvas {

	/**
	 *  The track this car follows, i.e. left turn, straight, ..
	 */
	//private Track track_;
	//public Track track() { return track_; }
	//public void track( Track aTrack ) { track_ = aTrack; }

	/**
	 *  The linear position of this VisibleCar on its
	 *   track (0<= position < 4000)
	 */
	private int position_;
	public int position() { return position_; }
	public void position( int anInt ) { position_ = anInt; }

	/**
	 *  The velocity vector of this VisibleCar
	 *  as a Point. x = delta x next cycle,
	 *  y = delta y next cycle
	 */
	private Point velocityVector_;
	public Point velocityVector() { return velocityVector_; }
	public void velocityVector( Point aVV ) { velocityVector_ = aVV; }

	/**
	 *  The radius of this VisibleCar in pixels
	 */
	private int radius_;
	public int radius() { return radius_; }
	public void radius( int anInt ) { radius_ = anInt; }

	/**
	 *  The current TravelerFrame for this VisibleCar
	 */
	private TravelerFrame currentTravelerFrame_;
	public TravelerFrame currentTravelerFrame() { return currentTravelerFrame_; }
	public void currentTravelerFrame( TravelerFrame aTF ) { currentTravelerFrame_ = aTF; }

    VisibleCar() {
        this.initialize();
    }

//    VisibleCar(Track aTrack) {
//        this();
//        this.track(aTrack);
//        this.currentTravelerFrame(this.track().getAppropriateTravelerFrame(this.position()));
//    }

    private void initialize() {
        this.setSize(24,34);
        this.position(0);
        this.radius(10);
  //      this.setLocation(0,0);
  //      this.track(new Track()); // get the actual random track later
  //      this.currentTravelerFrame(this.track().getAppropriateTravelerFrame(this.position()));
    }

    public void updatePixWithVelocity(int currentVelocity, Track theTrack) {
        this.position(this.position() + currentVelocity);
        TravelerFrame theFrame = theTrack
                   .getAppropriateTravelerFrame(this.position());
   //     double theDirection = this.direction(theTrack
    //               .getAppropriateTravelerFrame(this.position() + 600), theFrame);
        this.currentTravelerFrame(theFrame);

     //   System.out.println(this.angleToImageKey(theDirection));
    //    theFrame.angle(this.angleToImageKey(theDirection));

    //    this.currentTravelerFrame()
    //            .image( CarImageFinder.instance()
    //                   .findImage(this.angleToImageKey(theDirection)));

      //  this.repaint();
    }

    public double direction(TravelerFrame t2, TravelerFrame t1) {
        double angle = 0.0;
        boolean straight = false;
        int x2 = t2.position().x;
        int y2 = t2.position().y;
        int x1 = t1.position().x;
        int y1 = t1.position().y;
        double deltaX = x2 - x1;
        double deltaY = y2 - y1;

        if (x1 == x2) {
            // 0 or 180
            if (deltaY > 0.0) {
                return 180.0;
            }
            else {
                return 0.0;
            }
        }

        if (y1 == y2) {
            // 90 or 270
            if (deltaX > 0.0) {
                return 270.0;
            }
            else {
                return 90.0;
            }
        }

        double h = Math.sqrt((deltaX * deltaX) + (deltaY * deltaY));

        // handle the quadrant stuff

        if (deltaY > 0) {

            if (deltaX > 0) {
                // dy+ dx+
                angle = Math.asin(Math.abs(deltaX) / h) + (Math.PI);
            }
            else {
                // dy+ dx-
                angle = Math.asin(Math.abs(deltaY) / h) + (Math.PI / 2.0);
            }
        }
        else {
            if (deltaX > 0) {
                // dy- dx+
                angle = Math.asin(Math.abs(deltaY) / h) + (3.0 * Math.PI / 2.0);
            }
            else {
                // dy- dx-
                angle = Math.asin(Math.abs(deltaX) / h ) + (0.0);
            }
        }
        System.out.println("angle = " + angle*57.2958);
        return angle * 57.2958;
    }

    public String angleToImageKey(double angle) {
        int intValue = (new Double(angle)).intValue() / 10;
        intValue = intValue * 10;
        String stringAngle = Integer.toString(intValue);
        if (stringAngle.length() == 1) {
            return ("car" + "00" + stringAngle);
        }
        if (stringAngle.length() == 2) {
            return ("car" + "0" + stringAngle);
        }
        return "car" + stringAngle;
    }



    public void paint (Graphics g) {
      //  this.setLocation( this.currentTravelerFrame().position().x,
      //                    this.currentTravelerFrame().position().y );
// System.out.println("inside visiblecar paint");
      //   g.drawImage(this.currentTravelerFrame().image(), 0, 0, this);
    }

    public void update(Graphics g) {  paint(g);  }

}
