import java.awt.*;
import java.lang.*;
import java.text.*;
import java.util.*;
import java.awt.event.*;

public class WebPageAnalyzerView extends SCView {


	/**
	 *  The WebPageAnalyzer associated with this View
	 */
	private WebPageAnalyzer webPageAnalyzer_;
	public WebPageAnalyzer webPageAnalyzer() { return webPageAnalyzer_; }
	public void webPageAnalyzer( WebPageAnalyzer aWebPageAnalyzer ) { webPageAnalyzer_ = aWebPageAnalyzer; }

    public static void main(String argv[]){

        System.out.println("- WebPageAnalyzerView Begins ");
        WebPageAnalyzerView theWebPageAnalyzerView = new WebPageAnalyzerView();
        theWebPageAnalyzerView.show();
    }

    public WebPageAnalyzerView(){
        super("Web Page Analyzer View");
        this.initialize();
    }

    private void initialize() {

        this.webPageAnalyzer(new WebPageAnalyzer());

        this.initMenu();
        this.initLists();
        this.initLabels();
    //    this.initButtons();
        this.initTextFields();
/*

        Enumeration enum = this.videoStore().promotionNames();
        while( enum.hasMoreElements() ){
            ((List) this.getWidget("promotionList")).
                addItem( (String) enum.nextElement() );
        }

        enum = this.videoStore().tapes();
        while( enum.hasMoreElements() ){
            Tape aTape = (Tape) enum.nextElement();
            String tapeString = aTape.id() + "  " + aTape.title();
            ((List) this.getWidget("tapeList")).
                addItem( tapeString );
        }
*/

        this.setSize(486,498);
        this.setLocation(200,200);


    }

    private void initTextFields(){
        TextField aTextField = new TextField();
        aTextField.setSize(327,23);
        aTextField.setLocation(108,60);
        this.addWidget("URL TextField", aTextField);
    }
    private void initMenu(){
        MenuBar aMenuBar = new MenuBar();

            Menu aMenu = new Menu("File");

                MenuItem aMenuItem = new MenuItem("Exit");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Exit");
                aMenu.add(aMenuItem);

            aMenuBar.add(aMenu);

            aMenu = new Menu("Edit");

                aMenuItem = new MenuItem("Cut");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Cut");
                aMenu.add(aMenuItem);

                aMenuItem = new MenuItem("Copy");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Copy");
                aMenu.add(aMenuItem);

                aMenuItem = new MenuItem("Paste");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Paste");
                aMenu.add(aMenuItem);

            aMenuBar.add(aMenu);

            aMenu = new Menu("View");

                aMenuItem = new MenuItem("All Projects");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("AllProjects");
                aMenu.add(aMenuItem);

                aMenuItem = new MenuItem("URL Rankings");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("URLRankings");
                aMenu.add(aMenuItem);

            aMenuBar.add(aMenu);

        this.setMenuBar(aMenuBar);

    }

    private void initLists(){

        List aList = new List();
        aList.setSize(272,273);
        aList.setLocation(120,144);
        aList.setMultipleMode(false);
        aList.addItemListener(this);
        this.addWidget("words",aList);
    }

    private void initLabels(){

        Font bigFont = new Font("Helvetica",Font.BOLD,20);
        Font mediumFont = new Font("Helvetica",Font.BOLD,14);
        Font smallFont = new Font("Helvetica",Font.BOLD,10);

        Label aLabel = new Label("URL");
        aLabel.setFont( mediumFont );
        aLabel.setSize(40,24);
        aLabel.setLocation(48,60);
        this.addWidget("customerIDLabel",aLabel);

        aLabel = new Label("Word List");
        aLabel.setFont( mediumFont );
        aLabel.setSize(96,24);
        aLabel.setLocation(204,108);
        this.addWidget("wordList",aLabel);

    }

    public void openAllProjectsDialog() {
    }

    public void actionPerformed(ActionEvent e){
        String command = (String) e.getActionCommand();
        if(command == "AllProjects"){
            this.openAllProjectsDialog();
            return;
        }
        if(command == "Exit"){
            this.exit();
            return;
        }
    }
    public void itemStateChanged( ItemEvent ie ){
/*
        System.out.println("itemStateChanged in VideoPricerView");
        System.out.println(((List) this.getWidget("tapeList")).getSelectedItems());

        Vector tapeIDs = new Vector();

        String items[] = ((List) this.getWidget("tapeList")).getSelectedItems();
        if( items.length == 0 ) {
            ((Label) this.getWidget("chargeLabel")).setText("0.00");
            return;
        }

        for( int i = 0; i < items.length; i++ ){
            String s = items[i].substring(0,9);
            tapeIDs.addElement( s );
        }

        Vector promotionNames = new Vector();
        items = ((List) this.getWidget("promotionList")).getSelectedItems();
        for( int i = 0; i < items.length; i++ ){
            promotionNames.addElement( items[i] );
        }

        String customerID = ((TextField) this.getWidget("customerIDTextField")).getText();
        double price =
            this.videoStore().calculatePrice( tapeIDs, promotionNames, customerID );


            NumberFormat theNF = NumberFormat.getCurrencyInstance();
        String result = theNF.format(price);


        ((Label) this.getWidget("chargeLabel")).setText(result);
        System.out.println("and the price is...   " + price);
*/

    }
    public void windowClosing(WindowEvent e){
        this.exit();
    }

    private void exit(){
        this.hide();
    }

}
