import java.util.*;

class WestLeftLane extends Lane {
    WestLeftLane(TrafficLiteController tlc){
        super(tlc);
        RegularLightBox aRLB = new RegularLightBox();
        this.lightBox( aRLB );
        this.lightBox().addObserver(this);
    }
    public void sensorActivated(){
        this.greenRequest( new GreenRequest() );
    }
    public void setConflicts(){
        this.conflictingLanes().addElement( this.trafficLiteController().getLane( "SouthThruLane" ) );
        this.conflictingLanes().addElement( this.trafficLiteController().getLane( "SouthLeftLane" ) );
        this.conflictingLanes().addElement( this.trafficLiteController().getLane( "NorthThruLane" ) );
        this.conflictingLanes().addElement( this.trafficLiteController().getLane( "NorthLeftLane" ) );
        this.conflictingLanes().addElement( this.trafficLiteController().getLane( "EastThruLane" ) );
        this.conflictingLanes().addElement( this.trafficLiteController().getLane( "NorthPedLane" ) );
        this.conflictingLanes().addElement( this.trafficLiteController().getLane( "WestPedLane" ) );
    }

	public void update(Observable obs, Object o){
	    if( ((String) o).equals("resetGreenRequest")){
	        this.greenRequest(null);
	        return;
	    }
		this.trafficLiteController().instructLight( "WLLight" ,(String) o);
	}
}