

Application create: #TPZoo with:
        (#( Kernel)
            collect: [:each | Smalltalk at: each ifAbsent: [
                self error: 'Not all of the prerequisites are loaded']])!

TPZoo becomeDefault!
Object subclass: #Animal
    instanceVariableNames: 'name footCount '
    classVariableNames: ''
    poolDictionaries: ''!

TPZoo becomeDefault!
Application subclass: #TPZoo
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

TPZoo becomeDefault!
Object subclass: #Zoo
    instanceVariableNames: 'name animalCollection '
    classVariableNames: ''
    poolDictionaries: ''!

TPZoo becomeDefault!

!Animal publicMethods !

footCount
	"Answer the number of feet
       this animal has"
	^footCount.!

footCount: aNumber
	"Set  the footCount for this Animal
        to aNumber"
	footCount := aNumber.!

name
	"Answer the name for this Animal"
	^name.!

name: aString
	"Set  the name for this Animal
        to aString"
	name := aString.! !

Animal categoriesFor: #footCount are:((Array basicNew: 1)
	at: 1 put: 'Not categorized';
	yourself)!
Animal categoriesFor: #name: are:((Array basicNew: 1)
	at: 1 put: 'Not categorized';
	yourself)!
Animal categoriesFor: #footCount: are:((Array basicNew: 1)
	at: 1 put: 'Not categorized';
	yourself)!
Animal categoriesFor: #name are:((Array basicNew: 1)
	at: 1 put: 'Not categorized';
	yourself)!

!Zoo class publicMethods !

new
	"Answer an initialized Zoo instance"
	| aZoo theAnimals anAnimal |

	aZoo := super new.
	theAnimals := OrderedCollection new.

	anAnimal := Animal new.
	anAnimal name: 'Bill'.
	anAnimal footCount: 3.
	theAnimals add: anAnimal.

	anAnimal := Animal new.
	anAnimal name: 'Centi'.
	anAnimal footCount: 100.
	theAnimals add: anAnimal.

	aZoo animalCollection: theAnimals.
	aZoo name: 'Congress'.

	^aZoo.! !

Zoo class categoriesFor: #new are:((Array basicNew: 1)
	at: 1 put: 'Not categorized';
	yourself)!

!Zoo publicMethods !

animalCollection
	"Answer the animalCollection for this Zoo"
	^animalCollection.!

animalCollection: anOrderedCollection
	"Set the animalCollection for this Zoo
            to anOrderedCollection"
	animalCollection := anOrderedCollection.!

getTotalFootCount
	"Answer the total number
       of feet (or hooves) in the Zoo"

	| totalFeet |

	totalFeet := 0.
	self animalCollection do: [ :anAnimal |
		totalFeet := totalFeet + anAnimal footCount.
	].
	^totalFeet.!

name
	"Answer the name for this Zoo"
	^name.!

name: aString
	"Set the name for this Zoo
            to aString"
	name := aString.! !

Zoo categoriesFor: #getTotalFootCount are:((Array basicNew: 1)
	at: 1 put: 'Not categorized';
	yourself)!
Zoo categoriesFor: #name are:((Array basicNew: 1)
	at: 1 put: 'Not categorized';
	yourself)!
Zoo categoriesFor: #animalCollection are:((Array basicNew: 1)
	at: 1 put: 'Not categorized';
	yourself)!
Zoo categoriesFor: #name: are:((Array basicNew: 1)
	at: 1 put: 'Not categorized';
	yourself)!
Zoo categoriesFor: #animalCollection: are:((Array basicNew: 1)
	at: 1 put: 'Not categorized';
	yourself)!
