import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class ExampleView extends Frame implements ActionListener, WindowListener, Observer  {


	/**
	 */
	private ExampleBusinessModel exampleBusinessModel_;
	public ExampleBusinessModel exampleBusinessModel() { return exampleBusinessModel_; }
	public void exampleBusinessModel( ExampleBusinessModel anExampleBusinessModel ) { exampleBusinessModel_ = anExampleBusinessModel; }

	/**
	 */
	private FlashingCanvas flashingCanvas_;
	public FlashingCanvas flashingCanvas() { return flashingCanvas_; }
	public void flashingCanvas( FlashingCanvas aFlashingCanvas ) { flashingCanvas_ = aFlashingCanvas; }

    public static void main(String alf[]){
        System.out.println("top of main in ExampleView");

        ExampleView ev = new ExampleView();
        ev.show();



    }
    public ExampleView(){
        super("Example View");
        this.initialize();
    }

    private void initialize(){

        this.setLayout(null);

        this.addWindowListener( this );

         MenuBar aMenuBar = new MenuBar();

            Menu aMenu = new Menu("Example View");

                MenuItem aMenuItem = new MenuItem("Exit");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Exit");

            aMenu.add(aMenuItem);

        aMenuBar.add(aMenu);


        this.setMenuBar(aMenuBar);


        this.flashingCanvas( new FlashingCanvas() );
        this.add( this.flashingCanvas() );

        Button aButton = new Button("Tickle the Business Model");
        aButton.setSize(150,50);
        aButton.setLocation(10,70);
        aButton.setActionCommand("tickle button pressed");
        aButton.addActionListener( this );
        this.add( aButton );


        this.exampleBusinessModel( new ExampleBusinessModel() );
        this.exampleBusinessModel().addObserver(this);

        this.setSize(170,400);

    }

    public void update(Observable obs, Object o){

        System.out.println("update in ExampleView, about to flash canvas");

        this.flashingCanvas().flash();



    }

    public void actionPerformed( ActionEvent ae ){
        String actionCommand = ae.getActionCommand();
        System.out.println("actionPerformed in ExampleView, actionCommand = " + actionCommand);

        if( actionCommand.equals("Exit") ){
            this.exit();
            return;
        }

        if( actionCommand.equals("tickle button pressed") ){
            this.exampleBusinessModel().tickle();
            return;
        }
    }

    public void exit(){
        System.exit(0);
    }


    public void windowActivated     (WindowEvent e){}
    public void windowClosed        (WindowEvent e){}
    public void windowClosing       (WindowEvent e){

        this.exit();


    }
    public void windowOpened        (WindowEvent e){}
    public void windowDeactivated   (WindowEvent e){}
    public void windowIconified     (WindowEvent e){}
    public void windowDeiconified   (WindowEvent e){}




}