
import java.awt.*;
import java.io.*;
import java.awt.event.*;

class YesNoDialog extends Dialog implements ActionListener {

    private boolean yesChosen_;

    private String message_;

    public YesNoDialog(Frame f,String message){

        super(f,"",true);
        this.message_ = message;
        this.initialize();
    }

    private void initialize(){
        this.yesChosen_ = false;
        this.setLayout(null);
        this.setResizable(false);
        this.initWidgets();

        this.setSize(250,150);
        this.setLocation(275,175);
    }

    private void initWidgets(){

        Button aButton = new Button("Yes");
        aButton.setSize(90,30);
        aButton.setLocation(10,50);
        aButton.setFont(new Font("Courier",0,14));
        aButton.setActionCommand("Yes");
        aButton.addActionListener(this);
        this.add(aButton);

        aButton = new Button("No");
        aButton.setSize(90,30);
        aButton.setLocation(105,50);
        aButton.setFont(new Font("Courier",0,14));
        aButton.setActionCommand("No");
        aButton.addActionListener(this);
        this.add(aButton);

        Label aLabel = new Label(this.message_);
        aLabel.setSize(200,30);
        aLabel.setLocation(10,25);
        aLabel.setFont(new Font("Courier",0,14));
        aLabel.setAlignment(Label.LEFT);
        this.add(aLabel);

    }

   public void actionPerformed(ActionEvent e){
        String actionCommand = e.getActionCommand();
        if( actionCommand.equals("Yes") ){
            this.yesChosen_ = true;
            this.hide();
            return;
        }
        if( actionCommand.equals("No") ){
            this.yesChosen_ = false;
            this.hide();
            return;
        }
    }

    public boolean yesChosen(){
        return this.yesChosen_;
    }
    public boolean noChosen(){
        return !this.yesChosen_;
    }

}
